searchNodes=[{"doc":"Convenience macros to work with Aja's data structures.Use import A to import everything, or import only the macros you need.","ref":"A.html","title":"A","type":"module"},{"doc":"Convenience operator to concatenate an enumerable right to a vector left.left has to be an A.Vector, right can be any Enumerable.It is just an alias for A.Vector.concat/2.Only available on Elixir versions &gt;= 1.11.Examplesiex&gt; import A iex&gt; vec(5..1) +++ vec([:boom, nil]) #A&lt;vec([5, 4, 3, 2, 1, :boom, nil])&gt; iex&gt; vec(5..1) +++ 0..3 #A&lt;vec([5, 4, 3, 2, 1, 0, 1, 2, 3])&gt;","ref":"A.html#+++/2","title":"A.+++/2","type":"function"},{"doc":"Convenience macro to work with A.ExRanges (exclusive ranges).Use import A to use it, or import A, only: [~&gt;: 2].Examplesiex&gt; 1 ~&gt; 5 1 ~&gt; 5 iex&gt; start ~&gt; stop = 0 ~&gt; 10 iex&gt; {start, stop} {0, 10} iex&gt; for i &lt;- 0 ~&gt; 5, do: &quot;id_\#{i}&quot; [&quot;id_0&quot;, &quot;id_1&quot;, &quot;id_2&quot;, &quot;id_3&quot;, &quot;id_4&quot;]","ref":"A.html#~%3E/2","title":"A.~>/2","type":"macro"},{"doc":"Convenience macro to create or pattern match on A.OrdMaps.Use import A to use it, or import A, only: [ord: 1].Creation examplesiex&gt; ord(%{&quot;一&quot; =&gt; 1, &quot;二&quot; =&gt; 2, &quot;三&quot; =&gt; 3}) #A&lt;ord(%{&quot;一&quot; =&gt; 1, &quot;二&quot; =&gt; 2, &quot;三&quot; =&gt; 3})&gt; iex&gt; ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;}) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt;Pattern matching examplesiex&gt; ord(%{b: bat}) = ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;}) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt; iex&gt; bat &quot;Bat&quot;Replace existing keys examplesiex&gt; ordered = ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;}) iex&gt; ord(%{ordered | b: &quot;Buffalo&quot;}) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Buffalo&quot;, c: &quot;Cat&quot;})&gt; iex&gt; ord(%{ordered | z: &quot;Zebra&quot;}) ** (KeyError) key :z not found in: #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt;","ref":"A.html#ord/1","title":"A.ord/1","type":"macro"},{"doc":"A sigil to build IO data and avoid string concatenation.Use import A to use it, or import A, only: [sigil_i: 2].This sigil provides a faster version of string interpolation which:will build a list with all chunks instead of concatenating them as a stringuses A.IO.to_iodata/1 on interpolated values instead of to_string/1, which:will keep lists untouched, without any validation or transformationwill cast anything else using to_string/1Works with both IO data and Chardata. See their respective documentation for more information.Examplesiex&gt; ~i&quot;atom: \#{:foo}, charlist: \#{&#39;abc&#39;}, number: \#{12 + 2.35}\\n&quot; [&quot;atom: &quot;, &quot;foo&quot;, &quot;, charlist: &quot;, &#39;abc&#39;, &quot;, number: &quot;, &quot;14.35&quot;, 10] iex&gt; ~i&quot;abc\#{[&#39;def&#39; | &quot;ghi&quot;]}&quot; [&quot;abc&quot;, [&#39;def&#39; | &quot;ghi&quot;]] iex&gt; ~i&quot;Giorno Giovanna&quot; &quot;Giorno Giovanna&quot; IO data can often be used as is without ever generating the corresponding string. If needed however, IO data can be cast as a string using IO.iodata_to_binary/1, and chardata using List.to_string/1. In most cases, both should be the same:iex&gt; IO.iodata_to_binary(~i&quot;atom: \#{:foo}, charlist: \#{&#39;abc&#39;}, number: \#{12 + 2.35}\\n&quot;) &quot;atom: foo, charlist: abc, number: 14.35\\n&quot; iex&gt; List.to_string(~i&quot;abc\#{[&#39;def&#39; | &quot;ghi&quot;]}&quot;) &quot;abcdefghi&quot; Those are the exact same values returned by a regular string interpolation, without the ~i sigil:iex&gt; &quot;atom: \#{:foo}, charlist: \#{&#39;abc&#39;}, number: \#{12 + 2.35}\\n&quot; &quot;atom: foo, charlist: abc, number: 14.35\\n&quot; iex&gt; &quot;abc\#{[&#39;def&#39; | &quot;ghi&quot;]}&quot; &quot;abcdefghi&quot;","ref":"A.html#sigil_i/2","title":"A.sigil_i/2","type":"macro"},{"doc":"Convenience macro to create or pattern match on A.Vectors.It can only work with known-size vectors.Examplesiex&gt; import A iex&gt; vec([1, 2, 3]) #A&lt;vec([1, 2, 3])&gt; iex&gt; vec([1, 2, var, _, _, _]) = A.Vector.new(1..6) #A&lt;vec([1, 2, 3, 4, 5, 6])&gt; iex&gt; var 3 iex&gt; vec([_, _, _]) = A.Vector.new(1..6) ** (MatchError) no match of right hand side value: #A&lt;vec([1, 2, 3, 4, 5, 6])&gt;It also supports ranges with constant values:iex&gt; vec(0..4) = A.Vector.new(0..4) #A&lt;vec([0, 1, 2, 3, 4])&gt; iex&gt; vec(0~&gt;8) #A&lt;vec([0, 1, 2, 3, 4, 5, 6, 7])&gt;Variable lists or dynamic ranges cannot be passed:vec(my_list) # invalid vec(1..n) # invalidExplanationThe vec/1 macro generates the AST at compile time instead of building the vector at runtime. This can speedup the instanciation of vectors of known size.iex&gt; import A iex&gt; quote do vec([1, foo, _]) end |&gt; Macro.expand(__ENV__) |&gt; Macro.to_string() &quot;%A.Vector{__vector__: {3, {1, foo, _, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil}}}&quot;","ref":"A.html#vec/1","title":"A.vec/1","type":"macro"},{"doc":"Returns the size of a vector.It is implemented as a macro so that it can be used in guards.When used outside of a guard, it will just be replaced by a call to A.Vector.size/1.When used in guards, it will fail if called on something else than an A.Vector. It is recommended to verify the type first.Runs in constant time.Examplesiex&gt; import A iex&gt; match?(v when vec_size(v) &gt; 20, A.Vector.new(1..10)) false iex&gt; match?(v when vec_size(v) &lt; 5, A.Vector.new([1, 2, 3])) true iex&gt; vec_size(A.Vector.new([1, 2, 3])) 3","ref":"A.html#vec_size/1","title":"A.vec_size/1","type":"macro"},{"doc":"Some extra helper functions for working with enumerables, that are not in the core Enum module.","ref":"A.Enum.html","title":"A.Enum","type":"module"},{"doc":"Sorts the enumerable and removes duplicates.It is more efficient than calling Enum.sort/1 followed by Enum.uniq/1, and slightly faster than Enum.sort/1 followed by Enum.dedup/1.Examplesiex&gt; A.Enum.sort_uniq([1, 4, 2, 2, 3, 1, 4, 3]) [1, 2, 3, 4]","ref":"A.Enum.html#sort_uniq/1","title":"A.Enum.sort_uniq/1","type":"function"},{"doc":"Sorts the enumerable by the given function and removes duplicates.See Enum.sort/2 for more details about how the second parameter works.Examplesiex&gt; A.Enum.sort_uniq([1, 4, 2, 2, 3, 1, 4, 3], &amp;(&amp;1 &gt;= &amp;2)) [4, 3, 2, 1] iex&gt; A.Enum.sort_uniq([1, 4, 2, 2, 3, 1, 4, 3], :asc) [1, 2, 3, 4] iex&gt; A.Enum.sort_uniq([1, 4, 2, 2, 3, 1, 4, 3], :desc) [4, 3, 2, 1] iex&gt; dates = [~D[2019-01-01], ~D[2020-03-02], ~D[2019-01-01], ~D[2020-03-02]] iex&gt; A.Enum.sort_uniq(dates, {:desc, Date}) [~D[2020-03-02], ~D[2019-01-01]]","ref":"A.Enum.html#sort_uniq/2","title":"A.Enum.sort_uniq/2","type":"function"},{"doc":"Exclusive ranges are an exact copy of regular ranges (see Range), except that they exclude the second parameter.Why/when would you need exclusive ranges?The most typical use case would be when using 1..n for loops based on a parameter n &gt;= 0:iex&gt; incorrect = fn n -&gt; for i &lt;- 1..n, do: &quot;id_\#{i}&quot; end iex&gt; incorrect.(3) # works fine in general... [&quot;id_1&quot;, &quot;id_2&quot;, &quot;id_3&quot;] iex&gt; incorrect.(0) # weird bug at edge case! [&quot;id_1&quot;, &quot;id_0&quot;]To fix it, you would typically need to match the n == 0 case and handle it differently, which is adds noise. With exclusive ranges like 0 ~&gt; n, you get to keep the compact and elegant approach from above, while having a correct algorithm that covers the edge case:iex&gt; correct = fn n -&gt; for i &lt;- 1 ~&gt; n + 1, do: &quot;id_\#{i}&quot; end iex&gt; correct.(3) # works fine [&quot;id_1&quot;, &quot;id_2&quot;, &quot;id_3&quot;] iex&gt; correct.(0) # edge case works fine too []Exclusive ranges can be either increasing (start &lt;= stop) or decreasing (start &gt; stop). The start parameter is included (except if start == stop), the stop parameter is always excluded.An exclusive range is represented internally as a struct A.ExRange{start: start, stop: stop} and can be used as is.The A.~&gt;/2 convenience macro makes it possible to have a more compact syntax, similar to ../2. It is totally optional and needs to be imported:iex&gt; import A iex&gt; import A, only: [~&gt;: 2] # more selectiveExamples:iex&gt; A.ExRange.new(5) #A&lt;0 ~&gt; 5&gt; iex&gt; range = 0 ~&gt; 5 #A&lt;0 ~&gt; 5&gt; iex&gt; start ~&gt; stop = range iex&gt; {start, stop} iex&gt; {0, 4} iex&gt; Enum.to_list(range) [0, 1, 2, 3, 4] iex&gt; Enum.count(range) 5 iex&gt; Enum.member?(range, 5) false iex&gt; Enum.member?(range, 4) true iex&gt; Enum.to_list(3 ~&gt; 0) [3, 2, 1]Just like Ranges, such function calls are efficient memory-wise no matter the size of the range. The implementation of the Enumerable protocol uses logic based solely on the endpoints and does not materialize the whole list of integers.","ref":"A.ExRange.html","title":"A.ExRange","type":"module"},{"doc":"Checks if two ranges are disjoint.Examplesiex&gt; A.ExRange.disjoint?(1 ~&gt; 6, 6 ~&gt; 9) true iex&gt; A.ExRange.disjoint?(6 ~&gt; 1, 6 ~&gt; 9) true iex&gt; A.ExRange.disjoint?(1 ~&gt; 6, 5 ~&gt; 9) false iex&gt; A.ExRange.disjoint?(1 ~&gt; 6, 2 ~&gt; 7) false","ref":"A.ExRange.html#disjoint?/2","title":"A.ExRange.disjoint?/2","type":"function"},{"doc":"Creates a new exclusive range. start defaults to 0.Examplesiex&gt; A.ExRange.new(0, 100) #A&lt;0 ~&gt; 100&gt; iex&gt; A.ExRange.new(10) #A&lt;0 ~&gt; 10&gt;","ref":"A.ExRange.html#new/2","title":"A.ExRange.new/2","type":"function"},{"doc":"","ref":"A.ExRange.html#t:t/0","title":"A.ExRange.t/0","type":"type"},{"doc":"Some extra helper functions for working with IO data, that are not in the core IO module.","ref":"A.IO.html","title":"A.IO","type":"module"},{"doc":"Checks if IO data is empty in &quot;constant&quot; time.Should only need to loop until it finds one character or binary to stop, unlike IO.iodata_length(iodata) == 0 which needs to perform the complete loop to compute the length first.Examplesiex&gt; A.IO.iodata_empty?([&quot;&quot;, []]) true iex&gt; A.IO.iodata_empty?(&#39;a&#39;) false iex&gt; A.IO.iodata_empty?([&quot;a&quot;]) false iex&gt; A.IO.iodata_empty?([&quot;&quot;, [], [&quot;&quot; | &quot;c&quot;]]) falseRationaleEven if IO.iodata_length/1 is a very efficient BIF implemented in C, it has a linear algorithmic complexity and can become slow if invoked on an IO list with many elements.This is not a far-fetched scenario, and a production use case can easily include &quot;big&quot; IO-lists with:JSON encoding to IO-data of long lists / nested objectsloops within HTML templates","ref":"A.IO.html#iodata_empty?/1","title":"A.IO.iodata_empty?/1","type":"function"},{"doc":"Converts the argument to IO data according to the String.Chars protocol.Leaves lists untouched without any validation, calls to_string/1 on everything else.This is the function invoked in string interpolations within the i sigil.Works with both IO data and Chardata, depending on the type of the data parameter.Examplesiex&gt; A.IO.to_iodata(:foo) &quot;foo&quot; iex&gt; A.IO.to_iodata(99) &quot;99&quot; iex&gt; A.IO.to_iodata([&quot;abc&quot;, &#39;def&#39; | &quot;ghi&quot;]) [&quot;abc&quot;, &#39;def&#39; | &quot;ghi&quot;]","ref":"A.IO.html#to_iodata/1","title":"A.IO.to_iodata/1","type":"function"},{"doc":"Some extra helper functions for working with integers, that are not in the core Integer module.","ref":"A.Integer.html","title":"A.Integer","type":"module"},{"doc":"Format integers for humans, with thousand separators.Examplesiex&gt; A.Integer.decimal_format(1_234_567) &quot;1,234,567&quot; iex&gt; A.Integer.decimal_format(-123) &quot;-123&quot; iex&gt; A.Integer.decimal_format(-1_234, separator: ?_) &quot;-1_234&quot;","ref":"A.Integer.html#decimal_format/2","title":"A.Integer.decimal_format/2","type":"function"},{"doc":"Returns both the result of div/2 and rem/2 at once.Examplesiex&gt; A.Integer.div_rem(7, 3) {2, 1} iex&gt; A.Integer.div_rem(-99, 2) {-49, -1} iex&gt; A.Integer.div_rem(100, 0) ** (ArithmeticError) bad argument in arithmetic expression","ref":"A.Integer.html#div_rem/2","title":"A.Integer.div_rem/2","type":"function"},{"doc":"Some extra helper functions for working with lists, that are not in the core List module.","ref":"A.List.html","title":"A.List","type":"module"},{"doc":"Prepends an element to a list, equivalent of [elem | list] that can be used in a pipe.Examplesiex&gt; [2, 3, 5, 8] |&gt; A.List.prepend(1) [1, 2, 3, 5, 8]","ref":"A.List.html#prepend/2","title":"A.List.prepend/2","type":"function"},{"doc":"Populates a list of size n by calling generator_fun repeatedly.Examples# Although not necessary, let&#39;s seed the random algorithm iex&gt; :rand.seed(:exsplus, {1, 2, 3}) iex&gt; A.List.repeatedly(&amp;:rand.uniform/0, 3) [0.40502929729990744, 0.45336720247823126, 0.04094511692041057] # It is basically just syntactic sugar for the following: iex&gt; Stream.repeatedly(&amp;:rand.uniform/0) |&gt; Enum.take(3)RationaleIt has a consistent API with Stream.repeatedly/1 and List.duplicate/2It provides a less verbose way of writing one of the most common uses of Stream.repeatedly/1It removes the temptation to write the following, which is more concise but is technically incorrect:iex&gt; incorrect = fn n -&gt; for _i &lt;- 1..n, do: :rand.uniform() end iex&gt; incorrect.(0) |&gt; length() 2 iex&gt; Enum.to_list(1..0) # &lt;- because of this [1, 0]This is the same problem that A.ExRange is addressing.","ref":"A.List.html#repeatedly/2","title":"A.List.repeatedly/2","type":"function"},{"doc":"A Map preserving key insertion order, with efficient lookups and updates.Works just like regular maps, except that the insertion order is preserved:iex&gt; %{&quot;one&quot; =&gt; 1, &quot;two&quot; =&gt; 2, &quot;three&quot; =&gt; 3} %{&quot;one&quot; =&gt; 1, &quot;three&quot; =&gt; 3, &quot;two&quot; =&gt; 2} iex&gt; A.OrdMap.new([{&quot;one&quot;, 1}, {&quot;two&quot;, 2}, {&quot;three&quot;, 3}]) #A&lt;ord(%{&quot;one&quot; =&gt; 1, &quot;two&quot; =&gt; 2, &quot;three&quot; =&gt; 3})&gt;There is an unavoidable overhead compared to natively implemented maps, so keep using regular maps when you do not care about the insertion order.A.OrdMap:provides efficient (logarithmic) access: it is not a simple list of tuplesimplements the Access behaviour, Enum / Inspect / Collectable protocolsoptionally implements the Jason.Encoder protocol if Jason is installedExamplesA.OrdMap offers the same API as Map :iex&gt; ord_map = A.OrdMap.new([b: &quot;Bat&quot;, a: &quot;Ant&quot;, c: &quot;Cat&quot;]) #A&lt;ord(%{b: &quot;Bat&quot;, a: &quot;Ant&quot;, c: &quot;Cat&quot;})&gt; iex&gt; A.OrdMap.get(ord_map, :c) &quot;Cat&quot; iex&gt; A.OrdMap.fetch(ord_map, :a) {:ok, &quot;Ant&quot;} iex&gt; A.OrdMap.put(ord_map, :d, &quot;Dinosaur&quot;) #A&lt;ord(%{b: &quot;Bat&quot;, a: &quot;Ant&quot;, c: &quot;Cat&quot;, d: &quot;Dinosaur&quot;})&gt; iex&gt; A.OrdMap.put(ord_map, :b, &quot;Buffalo&quot;) #A&lt;ord(%{b: &quot;Buffalo&quot;, a: &quot;Ant&quot;, c: &quot;Cat&quot;})&gt; iex&gt; A.OrdMap.delete(ord_map, :b) #A&lt;ord(%{a: &quot;Ant&quot;, c: &quot;Cat&quot;})&gt; iex&gt; Enum.to_list(ord_map) [b: &quot;Bat&quot;, a: &quot;Ant&quot;, c: &quot;Cat&quot;] iex&gt; [d: &quot;Dinosaur&quot;, b: &quot;Buffalo&quot;, e: &quot;Eel&quot;] |&gt; Enum.into(ord_map) #A&lt;ord(%{b: &quot;Buffalo&quot;, a: &quot;Ant&quot;, c: &quot;Cat&quot;, d: &quot;Dinosaur&quot;, e: &quot;Eel&quot;})&gt;Tree-specific functionsDue to its sorted nature, A.OrdMap also offers some extra methods not present in Map, like:first/1 and last/1 to efficiently retrieve the first / last key-value pairpop_first/1 and pop_last/1 to efficiently pop the first / last key-value pairfoldl/3 and foldr/3 to efficiently fold (reduce) from left-to-right or right-to-leftExamples:iex&gt; ord_map = A.OrdMap.new(b: &quot;Bat&quot;, a: &quot;Ant&quot;, c: &quot;Cat&quot;) iex&gt; A.OrdMap.first(ord_map) {:b, &quot;Bat&quot;} iex&gt; {:c, &quot;Cat&quot;, updated} = A.OrdMap.pop_last(ord_map) iex&gt; updated #A&lt;ord(%{b: &quot;Bat&quot;, a: &quot;Ant&quot;})&gt; iex&gt; A.OrdMap.foldr(ord_map, [], fn _key, value, acc -&gt; [value &lt;&gt; &quot;man&quot; | acc] end) [&quot;Batman&quot;, &quot;Antman&quot;, &quot;Catman&quot;]Access behaviourA.OrdMap implements the Access behaviour.iex&gt; ord_map = A.OrdMap.new([a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;]) iex&gt; ord_map[:a] &quot;Ant&quot; iex&gt; put_in(ord_map[:b], &quot;Buffalo&quot;) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Buffalo&quot;, c: &quot;Cat&quot;})&gt; iex&gt; put_in(ord_map[:d], &quot;Dinosaur&quot;) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;, d: &quot;Dinosaur&quot;})&gt; iex&gt; {&quot;Cat&quot;, updated} = pop_in(ord_map[:c]); updated #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;})&gt;Convenience ord/1 macroThe A.OrdMap module can be used without any macro. The A.ord/1 macro does however provide some syntactic sugar to make it more convenient to work with ordered maps, namely:construct new ordered maps without the clutter of a entry listpattern match on key-values like regular mapsupdate some existing keysExamples:iex&gt; import A iex&gt; ord_map = ord(%{&quot;一&quot; =&gt; 1, &quot;二&quot; =&gt; 2, &quot;三&quot; =&gt; 3}) #A&lt;ord(%{&quot;一&quot; =&gt; 1, &quot;二&quot; =&gt; 2, &quot;三&quot; =&gt; 3})&gt; iex&gt; ord(%{&quot;三&quot; =&gt; three, &quot;一&quot; =&gt; one}) = ord_map iex&gt; {one, three} {1, 3} iex&gt; ord(%{ord_map | &quot;二&quot; =&gt; &quot;NI!&quot;}) #A&lt;ord(%{&quot;一&quot; =&gt; 1, &quot;二&quot; =&gt; &quot;NI!&quot;, &quot;三&quot; =&gt; 3})&gt;Note: pattern-matching on keys doesn't care about the insertion order.With Jasoniex&gt; A.OrdMap.new([{&quot;un&quot;, 1}, {&quot;deux&quot;, 2}, {&quot;trois&quot;, 3}]) |&gt; Jason.encode!() &quot;{\\&quot;un\\&quot;:1,\\&quot;deux\\&quot;:2,\\&quot;trois\\&quot;:3}&quot;It also preserves the insertion order. Comparing with a regular map:iex&gt; Map.new([{&quot;un&quot;, 1}, {&quot;deux&quot;, 2}, {&quot;trois&quot;, 3}]) |&gt; Jason.encode!() &quot;{\\&quot;deux\\&quot;:2,\\&quot;trois\\&quot;:3,\\&quot;un\\&quot;:1}&quot;There is no way as of now to decode JSON using A.OrdMap.Limitations: equalityA.OrdMap comparisons based on ==/2, ===/2 or the pin operator ^ are UNRELIABLE.In Elixir, pattern-matching and equality for structs work based on their internal representation. While this is a pragmatic design choice that simplifies the language, it means that we cannot rededine how they work for custom data structures.Two ordered maps that are semantically equal (same key-value pairs in the same order) might be considered non-equal when comparing their internals, because there is not a unique way of representing one same map.A.OrdMap.equal?/2 should be used instead:iex&gt; ord_map1 = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;})&gt; iex&gt; ord_map2 = A.OrdMap.new(c: &quot;Cat&quot;, a: &quot;Ant&quot;, b: &quot;Bat&quot;) |&gt; A.OrdMap.delete(:c) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;})&gt; iex&gt; ord_map1 == ord_map2 false iex&gt; A.OrdMap.equal?(ord_map1, ord_map2) true iex&gt; match?(^ord_map1, ord_map2) falsePattern-matching and opaque typeAn A.OrdMap is represented internally using the %A.OrdMap{} struct. This struct can be used whenever there's a need to pattern match on something being an A.OrdMap:iex&gt; match?(%A.OrdMap{}, A.OrdMap.new()) trueNote, however, than A.OrdMap is an opaque type: its struct internal fields must not be accessed directly.As discussed in the previous section, ord/1 makes it possible to pattern match on keys as well as checking the type.Memory overheadA.OrdMap takes roughly more memory 2.5~3x than a regular map depending on the type of data:iex&gt; map_size = 1..100 |&gt; Map.new(fn i -&gt; {i, &lt;&lt;i&gt;&gt;} end) |&gt; :erts_debug.size() 658 iex&gt; ord_map_size = 1..100 |&gt; A.OrdMap.new(fn i -&gt; {i, &lt;&lt;i&gt;&gt;} end) |&gt; :erts_debug.size() 1668 iex&gt; div(100 * ord_map_size, map_size) 253","ref":"A.OrdMap.html","title":"A.OrdMap","type":"module"},{"doc":"Deletes the entry in ord_map for a specific key.If the key does not exist, returns ord_map unchanged.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; A.OrdMap.delete(ord_map, :b) #A&lt;ord(%{a: &quot;Ant&quot;, c: &quot;Cat&quot;})&gt; iex&gt; A.OrdMap.delete(ord_map, :z) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt;","ref":"A.OrdMap.html#delete/2","title":"A.OrdMap.delete/2","type":"function"},{"doc":"Drops the given keys from ord_map.If keys contains keys that are not in ord_map, they're simply ignored.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; A.OrdMap.drop(ord_map, [:b, :d]) #A&lt;ord(%{a: &quot;Ant&quot;, c: &quot;Cat&quot;})&gt;","ref":"A.OrdMap.html#drop/2","title":"A.OrdMap.drop/2","type":"function"},{"doc":"Checks if two ordered maps are equal, meaning they have the same key-value pairs in the same order.Examplesiex&gt; A.OrdMap.equal?(A.OrdMap.new(a: 1, b: 2), A.OrdMap.new(a: 1, b: 2)) true iex&gt; A.OrdMap.equal?(A.OrdMap.new(a: 1, b: 2), A.OrdMap.new(b: 2, a: 1)) false iex&gt; A.OrdMap.equal?(A.OrdMap.new(a: 1, b: 2), A.OrdMap.new(a: 3, b: 2)) false","ref":"A.OrdMap.html#equal?/2","title":"A.OrdMap.equal?/2","type":"function"},{"doc":"Fetches the value for a specific key and returns it in a ok-entry. If the key does not exist, returns :error.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;A&quot;, b: &quot;B&quot;, c: &quot;C&quot;) iex&gt; A.OrdMap.fetch(ord_map, :c) {:ok, &quot;C&quot;} iex&gt; A.OrdMap.fetch(ord_map, :z) :error","ref":"A.OrdMap.html#fetch/2","title":"A.OrdMap.fetch/2","type":"function"},{"doc":"Fetches the value for a specific key in the given ord_map, erroring out if ord_map doesn't contain key.If ord_map doesn't contain key, a KeyError exception is raised.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;A&quot;, b: &quot;B&quot;, c: &quot;C&quot;) iex&gt; A.OrdMap.fetch!(ord_map, :c) &quot;C&quot; iex&gt; A.OrdMap.fetch!(ord_map, :z) ** (KeyError) key :z not found in: #A&lt;ord(%{a: &quot;A&quot;, b: &quot;B&quot;, c: &quot;C&quot;})&gt;","ref":"A.OrdMap.html#fetch!/2","title":"A.OrdMap.fetch!/2","type":"function"},{"doc":"Finds the fist {key, value} pair in ord_map.Returns a {key, value} entry if ord_map is non-empty, or nil else.Examplesiex&gt; A.OrdMap.new([b: &quot;B&quot;, d: &quot;D&quot;, a: &quot;A&quot;, c: &quot;C&quot;]) |&gt; A.OrdMap.first() {:b, &quot;B&quot;} iex&gt; A.OrdMap.new([]) |&gt; A.OrdMap.first() nil iex&gt; A.OrdMap.new([]) |&gt; A.OrdMap.first(:error) :error","ref":"A.OrdMap.html#first/2","title":"A.OrdMap.first/2","type":"function"},{"doc":"Folds (reduces) the given ord_map from the left with the function fun. Requires an accumulator acc.Examplesiex&gt; ord_map = A.OrdMap.new([b: &quot;Bat&quot;, c: &quot;Cat&quot;, a: &quot;Ant&quot;]) iex&gt; A.OrdMap.foldl(ord_map, &quot;&quot;, fn _key, value, acc -&gt; value &lt;&gt; acc end) &quot;AntCatBat&quot; iex&gt; A.OrdMap.foldl(ord_map, [], fn key, value, acc -&gt; [{key, value &lt;&gt; &quot;man&quot;} | acc] end) [a: &quot;Antman&quot;, c: &quot;Catman&quot;, b: &quot;Batman&quot;]","ref":"A.OrdMap.html#foldl/3","title":"A.OrdMap.foldl/3","type":"function"},{"doc":"Folds (reduces) the given ord_map from the right with the function fun. Requires an accumulator acc.Unlike linked lists, this is as efficient as foldl/3. This can typically save a call to Enum.reverse/1 on the result when building a list.Examplesiex&gt; ord_map = A.OrdMap.new([b: &quot;Bat&quot;, c: &quot;Cat&quot;, a: &quot;Ant&quot;]) iex&gt; A.OrdMap.foldr(ord_map, &quot;&quot;, fn _key, value, acc -&gt; value &lt;&gt; acc end) &quot;BatCatAnt&quot; iex&gt; A.OrdMap.foldr(ord_map, [], fn key, value, acc -&gt; [{key, value &lt;&gt; &quot;man&quot;} | acc] end) [b: &quot;Batman&quot;, c: &quot;Catman&quot;, a: &quot;Antman&quot;]","ref":"A.OrdMap.html#foldr/3","title":"A.OrdMap.foldr/3","type":"function"},{"doc":"Converts a struct to an ordered map.It accepts the struct module or a struct itself and simply removes the __struct__ field from the given struct or from a new struct generated from the given module.Exampledefmodule User do defstruct [:name, :age] end A.OrdMap.from_struct(User) #A&lt;ord(%{age: nil, name: nil})&gt; A.OrdMap.from_struct(%User{name: &quot;john&quot;, age: 44}) #A&lt;ord(%{age: 44, name: &quot;john&quot;})&gt;","ref":"A.OrdMap.html#from_struct/1","title":"A.OrdMap.from_struct/1","type":"function"},{"doc":"Gets the value for a specific key in ord_map.If key is present in ord_map then its value value is returned. Otherwise, default is returned.If default is not provided, nil is used.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; A.OrdMap.get(ord_map, :a) &quot;Ant&quot; iex&gt; A.OrdMap.get(ord_map, :z) nil iex&gt; A.OrdMap.get(ord_map, :z, &quot;Zebra&quot;) &quot;Zebra&quot;","ref":"A.OrdMap.html#get/3","title":"A.OrdMap.get/3","type":"function"},{"doc":"Gets the value from key and updates it, all in one pass.Mirrors Map.get_and_update/3, see its documentation.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; {&quot;bat&quot;, updated} = A.OrdMap.get_and_update(ord_map, :b, fn current_value -&gt; ...&gt; {current_value &amp;&amp; String.downcase(current_value), &quot;Buffalo&quot;} ...&gt; end) iex&gt; updated #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Buffalo&quot;, c: &quot;Cat&quot;})&gt; iex&gt; {nil, updated} = A.OrdMap.get_and_update(ord_map, :z, fn current_value -&gt; ...&gt; {current_value &amp;&amp; String.downcase(current_value), &quot;Zebra&quot;} ...&gt; end) iex&gt; updated #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;, z: &quot;Zebra&quot;})&gt; iex&gt; {&quot;Bat&quot;, updated} = A.OrdMap.get_and_update(ord_map, :b, fn _ -&gt; :pop end) iex&gt; updated #A&lt;ord(%{a: &quot;Ant&quot;, c: &quot;Cat&quot;})&gt; iex&gt; {nil, updated} = A.OrdMap.get_and_update(ord_map, :z, fn _ -&gt; :pop end) iex&gt; updated #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt;","ref":"A.OrdMap.html#get_and_update/3","title":"A.OrdMap.get_and_update/3","type":"function"},{"doc":"Gets the value from key and updates it, all in one pass.Mirrors Map.get_and_update!/3, see its documentation.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; {&quot;bat&quot;, updated} = A.OrdMap.get_and_update!(ord_map, :b, fn current_value -&gt; ...&gt; {current_value &amp;&amp; String.downcase(current_value), &quot;Buffalo&quot;} ...&gt; end) iex&gt; updated #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Buffalo&quot;, c: &quot;Cat&quot;})&gt; iex&gt; A.OrdMap.get_and_update!(ord_map, :z, fn current_value -&gt; ...&gt; {current_value &amp;&amp; String.downcase(current_value), &quot;Zebra&quot;} ...&gt; end) ** (KeyError) key :z not found in: #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt;","ref":"A.OrdMap.html#get_and_update!/3","title":"A.OrdMap.get_and_update!/3","type":"function"},{"doc":"Gets the value for a specific key in ord_map.If key is present in ord_map then its value value is returned. Otherwise, fun is evaluated and its result is returned.This is useful if the default value is very expensive to calculate or generally difficult to setup and teardown again.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; expensive_fun = fn -&gt; &quot;Zebra&quot; end iex&gt; A.OrdMap.get_lazy(ord_map, :a, expensive_fun) &quot;Ant&quot; iex&gt; A.OrdMap.get_lazy(ord_map, :z, expensive_fun) &quot;Zebra&quot;","ref":"A.OrdMap.html#get_lazy/3","title":"A.OrdMap.get_lazy/3","type":"function"},{"doc":"Returns whether the given key exists in ord_map.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; A.OrdMap.has_key?(ord_map, :a) true iex&gt; A.OrdMap.has_key?(ord_map, :d) false","ref":"A.OrdMap.html#has_key?/2","title":"A.OrdMap.has_key?/2","type":"function"},{"doc":"Returns all keys from ord_map.Examplesiex&gt; ord_map = A.OrdMap.new(b: &quot;Bat&quot;, c: &quot;Cat&quot;, a: &quot;Ant&quot;) iex&gt; A.OrdMap.keys(ord_map) [:b, :c, :a]","ref":"A.OrdMap.html#keys/1","title":"A.OrdMap.keys/1","type":"function"},{"doc":"Finds the last {key, value} pair in ord_map.Returns a {key, value} entry if ord_map is non-empty, or nil else. Can be accessed efficiently due to the underlying tree.Examplesiex&gt; A.OrdMap.new([b: &quot;B&quot;, d: &quot;D&quot;, a: &quot;A&quot;, c: &quot;C&quot;]) |&gt; A.OrdMap.last() {:c, &quot;C&quot;} iex&gt; A.OrdMap.new([]) |&gt; A.OrdMap.last() nil iex&gt; A.OrdMap.new([]) |&gt; A.OrdMap.last(:error) :error","ref":"A.OrdMap.html#last/2","title":"A.OrdMap.last/2","type":"function"},{"doc":"Merges two ordered maps into one.All keys in ord_map2 will be added to ord_map1, overriding any existing one (i.e., the keys in ord_map2 &quot;have precedence&quot; over the ones in ord_map1).Examplesiex&gt; A.OrdMap.merge(A.OrdMap.new(%{a: 1, b: 2}), A.OrdMap.new(%{a: 3, d: 4})) #A&lt;ord(%{a: 3, b: 2, d: 4})&gt;","ref":"A.OrdMap.html#merge/2","title":"A.OrdMap.merge/2","type":"function"},{"doc":"Returns a new empty ordered map.Examplesiex&gt; A.OrdMap.new() #A&lt;ord(%{})&gt;","ref":"A.OrdMap.html#new/0","title":"A.OrdMap.new/0","type":"function"},{"doc":"Creates an ordered map from an enumerable.Preserves the original order of keys. Duplicated keys are removed; the latest one prevails.Examplesiex&gt; A.OrdMap.new(b: &quot;Bat&quot;, a: &quot;Ant&quot;, c: &quot;Cat&quot;) #A&lt;ord(%{b: &quot;Bat&quot;, a: &quot;Ant&quot;, c: &quot;Cat&quot;})&gt; iex&gt; A.OrdMap.new(b: &quot;Bat&quot;, a: &quot;Ant&quot;, b: &quot;Buffalo&quot;, a: &quot;Antelope&quot;) #A&lt;ord(%{b: &quot;Buffalo&quot;, a: &quot;Antelope&quot;})&gt;","ref":"A.OrdMap.html#new/1","title":"A.OrdMap.new/1","type":"function"},{"doc":"Creates an ordered map from an enumerable via the given transform function.Preserves the original order of keys. Duplicated keys are removed; the latest one prevails.Examplesiex&gt; A.OrdMap.new([:a, :b], fn x -&gt; {x, x} end) #A&lt;ord(%{a: :a, b: :b})&gt;","ref":"A.OrdMap.html#new/2","title":"A.OrdMap.new/2","type":"function"},{"doc":"Returns the value for key and the updated ordered map without key.If key is present in the ordered map with a value value, {value, new_ord_map} is returned. If key is not present in the ordered map, {default, ord_map} is returned.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; {&quot;Bat&quot;, updated} = A.OrdMap.pop(ord_map, :b) iex&gt; updated #A&lt;ord(%{a: &quot;Ant&quot;, c: &quot;Cat&quot;})&gt; iex&gt; {nil, updated} = A.OrdMap.pop(ord_map, :z) iex&gt; updated #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt; iex&gt; {&quot;Z&quot;, updated} = A.OrdMap.pop(ord_map, :z, &quot;Z&quot;) iex&gt; updated #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt;","ref":"A.OrdMap.html#pop/3","title":"A.OrdMap.pop/3","type":"function"},{"doc":"Returns the value for key and the updated ordered map without key.Behaves the same as pop/3 but raises if key is not present in ord_map.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; {&quot;Bat&quot;, updated} = A.OrdMap.pop!(ord_map, :b) iex&gt; updated #A&lt;ord(%{a: &quot;Ant&quot;, c: &quot;Cat&quot;})&gt; iex&gt; A.OrdMap.pop!(ord_map, :z) ** (KeyError) key :z not found in: #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt;","ref":"A.OrdMap.html#pop!/2","title":"A.OrdMap.pop!/2","type":"function"},{"doc":"Finds and pops the first {key, value} pair in ord_map.Returns a {key, value, new_tree} entry for non-empty maps, nil for empty mapsExamplesiex&gt; ord_map = A.OrdMap.new([b: &quot;B&quot;, d: &quot;D&quot;, a: &quot;A&quot;, c: &quot;C&quot;]) #A&lt;ord(%{b: &quot;B&quot;, d: &quot;D&quot;, a: &quot;A&quot;, c: &quot;C&quot;})&gt; iex&gt; {:b, &quot;B&quot;, updated} = A.OrdMap.pop_first(ord_map) iex&gt; updated #A&lt;ord(%{d: &quot;D&quot;, a: &quot;A&quot;, c: &quot;C&quot;})&gt; iex&gt; A.OrdMap.new() |&gt; A.OrdMap.pop_first() nil","ref":"A.OrdMap.html#pop_first/1","title":"A.OrdMap.pop_first/1","type":"function"},{"doc":"Finds and pops the last {key, value} pair in ord_map.Returns a {key, value, new_tree} entry for non-empty maps, nil for empty mapsExamplesiex&gt; ord_map = A.OrdMap.new([b: &quot;B&quot;, d: &quot;D&quot;, a: &quot;A&quot;, c: &quot;C&quot;]) #A&lt;ord(%{b: &quot;B&quot;, d: &quot;D&quot;, a: &quot;A&quot;, c: &quot;C&quot;})&gt; iex&gt; {:c, &quot;C&quot;, updated} = A.OrdMap.pop_last(ord_map) iex&gt; updated #A&lt;ord(%{b: &quot;B&quot;, d: &quot;D&quot;, a: &quot;A&quot;})&gt; iex&gt; A.OrdMap.new() |&gt; A.OrdMap.pop_last() nil","ref":"A.OrdMap.html#pop_last/1","title":"A.OrdMap.pop_last/1","type":"function"},{"doc":"Lazily returns and removes the value associated with key in ord_map.If key is present in ord_map, it returns {value, new_map} where value is the value of the key and new_map is the result of removing key from ord_map. If key is not present in ord_map, {fun_result, ord_map} is returned, where fun_result is the result of applying fun.This is useful if the default value is very expensive to calculate or generally difficult to setup and teardown again.Examplesiex&gt; ord_map = A.OrdMap.new(b: &quot;Bat&quot;, a: &quot;Ant&quot;, c: &quot;Cat&quot;) iex&gt; expensive_fun = fn -&gt; &quot;Zebra&quot; end iex&gt; {&quot;Ant&quot;, updated} = A.OrdMap.pop_lazy(ord_map, :a, expensive_fun) iex&gt; updated #A&lt;ord(%{b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt; iex&gt; {&quot;Zebra&quot;, not_updated} = A.OrdMap.pop_lazy(ord_map, :z, expensive_fun) iex&gt; not_updated #A&lt;ord(%{b: &quot;Bat&quot;, a: &quot;Ant&quot;, c: &quot;Cat&quot;})&gt;","ref":"A.OrdMap.html#pop_lazy/3","title":"A.OrdMap.pop_lazy/3","type":"function"},{"doc":"Puts the given value under key in ord_map.If the key does exist, it overwrites the existing value without changing its current location.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; A.OrdMap.put(ord_map, :b, &quot;Buffalo&quot;) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Buffalo&quot;, c: &quot;Cat&quot;})&gt; iex&gt; A.OrdMap.put(ord_map, :d, &quot;Dinosaur&quot;) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;, d: &quot;Dinosaur&quot;})&gt;","ref":"A.OrdMap.html#put/3","title":"A.OrdMap.put/3","type":"function"},{"doc":"Puts the given value under key unless the entry key already exists in ord_map.Examplesiex&gt; ord_map = A.OrdMap.new(b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; A.OrdMap.put_new(ord_map, :a, &quot;Ant&quot;) #A&lt;ord(%{b: &quot;Bat&quot;, c: &quot;Cat&quot;, a: &quot;Ant&quot;})&gt; iex&gt; A.OrdMap.put_new(ord_map, :b, &quot;Buffalo&quot;) #A&lt;ord(%{b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt;","ref":"A.OrdMap.html#put_new/3","title":"A.OrdMap.put_new/3","type":"function"},{"doc":"Evaluates fun and puts the result under key in ord_map unless key is already present.This function is useful in case you want to compute the value to put under key only if key is not already present, as for example, when the value is expensive to calculate or generally difficult to setup and teardown again.Examplesiex&gt; ord_map = A.OrdMap.new(b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; expensive_fun = fn -&gt; &quot;Ant&quot; end iex&gt; A.OrdMap.put_new_lazy(ord_map, :a, expensive_fun) #A&lt;ord(%{b: &quot;Bat&quot;, c: &quot;Cat&quot;, a: &quot;Ant&quot;})&gt; iex&gt; A.OrdMap.put_new_lazy(ord_map, :b, expensive_fun) #A&lt;ord(%{b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt;","ref":"A.OrdMap.html#put_new_lazy/3","title":"A.OrdMap.put_new_lazy/3","type":"function"},{"doc":"Puts a value under key only if the key already exists in ord_map.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; A.OrdMap.replace(ord_map, :b, &quot;Buffalo&quot;) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Buffalo&quot;, c: &quot;Cat&quot;})&gt; iex&gt; A.OrdMap.replace(ord_map, :d, &quot;Dinosaur&quot;) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt;","ref":"A.OrdMap.html#replace/3","title":"A.OrdMap.replace/3","type":"function"},{"doc":"Puts a value under key only if the key already exists in ord_map.If key is not present in ord_map, a KeyError exception is raised.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; A.OrdMap.replace!(ord_map, :b, &quot;Buffalo&quot;) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Buffalo&quot;, c: &quot;Cat&quot;})&gt; iex&gt; A.OrdMap.replace!(ord_map, :d, &quot;Dinosaur&quot;) ** (KeyError) key :d not found in: #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt;","ref":"A.OrdMap.html#replace!/3","title":"A.OrdMap.replace!/3","type":"function"},{"doc":"Returns the number of keys in ord_map.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; A.OrdMap.size(ord_map) 3 iex&gt; A.OrdMap.size(A.OrdMap.new()) 0","ref":"A.OrdMap.html#size/1","title":"A.OrdMap.size/1","type":"function"},{"doc":"Returns a new ordered map with all the key-value pairs in ord_map where the key is in keys.If keys contains keys that are not in ord_map, they're simply ignored. Respects the order of the keys list.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; A.OrdMap.take(ord_map, [:c, :e, :a]) #A&lt;ord(%{c: &quot;Cat&quot;, a: &quot;Ant&quot;})&gt;","ref":"A.OrdMap.html#take/2","title":"A.OrdMap.take/2","type":"function"},{"doc":"Returns all values from ord_map.Examplesiex&gt; ord_map = A.OrdMap.new(b: &quot;Bat&quot;, c: &quot;Cat&quot;, a: &quot;Ant&quot;) iex&gt; A.OrdMap.to_list(ord_map) [b: &quot;Bat&quot;, c: &quot;Cat&quot;, a: &quot;Ant&quot;]","ref":"A.OrdMap.html#to_list/1","title":"A.OrdMap.to_list/1","type":"function"},{"doc":"Puts a value under key only if the key already exists in ord_map.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; A.OrdMap.update(ord_map, :b, &quot;N/A&quot;, &amp;String.upcase/1) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;BAT&quot;, c: &quot;Cat&quot;})&gt; iex&gt; A.OrdMap.update(ord_map, :z, &quot;N/A&quot;, &amp;String.upcase/1) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;, z: &quot;N/A&quot;})&gt;","ref":"A.OrdMap.html#update/4","title":"A.OrdMap.update/4","type":"function"},{"doc":"Puts a value under key only if the key already exists in ord_map.If key is not present in ord_map, a KeyError exception is raised.Examplesiex&gt; ord_map = A.OrdMap.new(a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;) iex&gt; A.OrdMap.update!(ord_map, :b, &amp;String.upcase/1) #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;BAT&quot;, c: &quot;Cat&quot;})&gt; iex&gt; A.OrdMap.update!(ord_map, :d, &amp;String.upcase/1) ** (KeyError) key :d not found in: #A&lt;ord(%{a: &quot;Ant&quot;, b: &quot;Bat&quot;, c: &quot;Cat&quot;})&gt;","ref":"A.OrdMap.html#update!/3","title":"A.OrdMap.update!/3","type":"function"},{"doc":"Returns all values from ord_map.Examplesiex&gt; ord_map = A.OrdMap.new(b: &quot;Bat&quot;, c: &quot;Cat&quot;, a: &quot;Ant&quot;) iex&gt; A.OrdMap.values(ord_map) [&quot;Bat&quot;, &quot;Cat&quot;, &quot;Ant&quot;]","ref":"A.OrdMap.html#values/1","title":"A.OrdMap.values/1","type":"function"},{"doc":"","ref":"A.OrdMap.html#t:key/0","title":"A.OrdMap.key/0","type":"type"},{"doc":"","ref":"A.OrdMap.html#t:t/0","title":"A.OrdMap.t/0","type":"opaque"},{"doc":"","ref":"A.OrdMap.html#t:t/2","title":"A.OrdMap.t/2","type":"opaque"},{"doc":"","ref":"A.OrdMap.html#t:value/0","title":"A.OrdMap.value/0","type":"type"},{"doc":"Convenience helpers for working with {atom, value} tuples without breaking the pipe.","ref":"A.Pair.html","title":"A.Pair","type":"module"},{"doc":"Unwraps an idiomatic {atom, value} tuple when the atom is what is being expected. Convenient for not breaking the pipe.Examplesiex&gt; {:ok, 55} |&gt; A.Pair.unwrap!(:ok) 55 iex&gt; :error |&gt; A.Pair.unwrap!(:ok) ** (ArgumentError) unwrap!/2 expected {:ok, _}, got: :error","ref":"A.Pair.html#unwrap!/2","title":"A.Pair.unwrap!/2","type":"function"},{"doc":"Wraps the value as an idiomatic {atom, value} tuple. Convenient for not breaking the pipe.Examplesiex&gt; 55 |&gt; A.Pair.wrap(:ok) {:ok, 55} iex&gt; %{a: 5} |&gt; Map.update!(:a, &amp; &amp;1 + 1) |&gt; A.Pair.wrap(:no_reply) {:no_reply, %{a: 6}}","ref":"A.Pair.html#wrap/2","title":"A.Pair.wrap/2","type":"function"},{"doc":"Some extra helper functions for working with strings, that are not in the core String module.","ref":"A.String.html","title":"A.String","type":"module"},{"doc":"Transforms the text as a slug. Removes whitespace, special characters and converts the rest to lowercase.This is typically useful to generate URLs based on content, e.g. the title of an article.Like String.downcase/2, slugify/2 also can handle the following modes: :default (keeps unicode), :ascii or :greek.Examplesiex&gt; A.String.slugify(&quot;&gt; \\&quot;It Was Me, Dio!!!\\&quot;\\n&quot;) &quot;it-was-me-dio&quot; iex&gt; A.String.slugify(&quot;Joseph Joestar a.k.a ジョジョ&quot;) &quot;joseph-joestar-aka-ジョジョ&quot; iex&gt; A.String.slugify(&lt;&lt;220&gt;&gt;) ** (ArgumentError) Invalid string &lt;&lt;220&gt;&gt;:ascii converts to ascii when possible or strips characters:iex&gt; A.String.slugify(&quot;OLÁ!\\n&quot;, :ascii) &quot;ola&quot; iex&gt; A.String.slugify(&quot;DIOの世界 -さらば友よ- &quot;, :ascii) &quot;dio&quot;:greek handles the context sensitive sigma in Greek:iex&gt; A.String.slugify(&quot;\\tΣΣ?&quot;) &quot;σσ&quot; iex&gt; A.String.slugify(&quot;\\tΣΣ?&quot;, :greek) &quot;σς&quot;","ref":"A.String.html#slugify/2","title":"A.String.slugify/2","type":"function"},{"doc":"","ref":"A.String.html#t:mode/0","title":"A.String.mode/0","type":"type"},{"doc":"A Clojure-like persistent vector with efficient appends and random access.Persistent vectors are an efficient alternative to lists. Many operations for A.Vector run in effective constant time (length, random access, appends...), unlike linked lists for which most operations run in linear time. Functions that need to go through the whole collection like map/2 or foldl/3 are as often fast as their list equivalents, or sometimes even slightly faster.Vectors also use less memory than lists for &quot;big&quot; collections (see the Memory usage section).Make sure to read the Efficiency guide section to get the best performance out of vectors.Erlang's :array module offer similar functionalities. However A.Vector:is a better Elixir citizen: pipe-friendliness, Access behaviour, Enum / Inspect / Collectable protocolsshould have higher performance in most use cases, especially &quot;loops&quot; like map/2 / to_list/1 / foldl/3mirrors the Enum module API, with highly optimized versions for vectors (join/1, sum/1, random/1...)supports negative indexing (e.g. -1 corresponds to the last element)optionally implements the Jason.Encoder protocol if Jason is installedNote: most of the design is inspired by this series of blog posts, but a branching factor of 16 = 2 ^ 4 has been picked instead of 32 = 2 ^ 5. This choice was made following performance benchmarking that showed better overall performance for this particular implementation.Examplesiex&gt; vector = A.Vector.new(1..10) #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8, 9, 10])&gt; iex&gt; A.Vector.append(vector, :foo) #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, :foo])&gt; iex&gt; vector[3] 4 iex&gt; A.Vector.replace_at(vector, -1, :bar) #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8, 9, :bar])&gt; iex&gt; 3 in vector trueAccess behaviourA.Vector implements the Access behaviour.iex&gt; vector = A.Vector.new(1..10) iex&gt; vector[3] 4 iex&gt; put_in(vector[5], :foo) #A&lt;vec([1, 2, 3, 4, 5, :foo, 7, 8, 9, 10])&gt; iex&gt; {9, updated} = pop_in(vector[8]); updated #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8, 10])&gt;Convenience vec/1 and vec_size/1 macrosThe A.Vector module can be used without any macro.The A.vec/1 macro does however provide some syntactic sugar to make it more convenient to work with vectors of known size, namely:pattern match on elements for vectors of known sizeconstruct new vectors of known size faster, by generating the AST at compile timeExamples:iex&gt; import A iex&gt; vec([1, 2, 3]) #A&lt;vec([1, 2, 3])&gt; iex&gt; vec([1, 2, var, _, _, _]) = A.Vector.new(1..6); var 3The A.vec_size/1 macro can be used in guards:iex&gt; import A iex&gt; match?(v when vec_size(v) &gt; 99, A.Vector.new(1..100)) trueConvenience +++/2 operatorThe A.+++/2 operator can make appending to a vector more compact by aliasing A.Vector.concat/2:iex&gt; import A iex&gt; vec([1, 2, 3]) +++ vec([4, 5]) #A&lt;vec([1, 2, 3, 4, 5])&gt;Pattern-matching and opaque typeAn A.Vector is represented internally using the %A.Vector{} struct. This struct can be used whenever there's a need to pattern match on something being an A.Vector:iex&gt; match?(%A.Vector{}, A.Vector.new()) trueNote, however, than A.Vector is an opaque type: its struct internal fields must not be accessed directly.As discussed in the previous section, vec/1 makes it possible to pattern match on size and elements as well as checking the type.Memory usageVectors have a small overhead over lists for smaller collections, but are using far less memory for bigger collections:iex&gt; memory_for = fn n -&gt; [Enum.to_list(1..n), A.Vector.new(1..n)] |&gt; Enum.map(&amp;:erts_debug.size/1) end iex&gt; memory_for.(1) [2, 28] iex&gt; memory_for.(10) [20, 28] iex&gt; memory_for.(100) [200, 150] iex&gt; memory_for.(10_000) [20000, 11370]If you need to work with vectors containing mostly the same value, A.Vector.duplicate/2 is highly efficient both in time and memory (logarithmic). It minimizes the number of actual copies and reuses the same nested structures under the hood:iex&gt; A.Vector.duplicate(0, 10_000) |&gt; :erts_debug.size() 116 iex&gt; A.Vector.duplicate(0, 10_000) |&gt; :erts_debug.flat_size() # when shared over processes / ETS 11370Even a 1B x 1B matrix of the same element costs virtually nothing!big_n = 1_000_000_000 0 |&gt; A.Vector.duplicate(big_n) |&gt; A.Vector.duplicate(big_n) |&gt; :erts_debug.size() 538Efficiency guideIf you are using vectors and not lists, chances are that you care about performance. Here are a couple notes about how to use vectors in an optimal way. Most functions from this module are highly efficient, those that are not will indicate it in their documentation.But remember the golden rule: in case of doubt, always benchmark.Avoid prependingAppending is very efficient, but prepending is highly inefficient since the whole array needs to be reconstructed.DON'TA.Vector.prepend(vector, :foo)DO[:foo | list] # use lists A.Vector.append(vector, :foo)Avoid deletionsThis implementation of persistent vectors has many advantages, but it does not support efficient deletion, with the exception of the last element that can be popped very efficiently (A.Vector.pop_last/1, A.Vector.delete_last/1).Deleting close to the end of the vector is still fairly fast, but deleting near the beginning needs to reconstruct most of the vector.Deletion functionality is provided through functions like A.Vector.pop_at/3 and A.Vector.delete_at/2 for the sake of completion, but please note that they are inefficient and their usage is discouraged.If you need to be able to pop arbitrary indexes, chances are you should consider an alternative data structure. Another possibility could be to use sparse arrays, defining nil as a deleted value (but then the indexing and size won't reflect this).DON'TA.Vector.pop_at(vector, 3) A.Vector.delete_at(vector, 3) pop_in(vector[3])DOA.Vector.pop_last(vector) A.Vector.delete_last(vector) A.Vector.delete_at(vector, -3) # close to the end A.Vector.replace_at(vector, 3, nil)Successive appendsIf you just need to append all elements of an enumerable, it is more efficient to use A.Vector.concat/2 or its alias A.+++/2 than successive calls to A.Vector.append/2:DON'TEnum.reduce(enumerable, vector, fn val, acc -&gt; A.Vector.append(acc, val) end) Enum.into(enumerable, vector)DOA.Vector.concat(vector, enumerable) vector +++ enumerablePrefer A.Vector to Enum for vectorsMany functions provided in this module are very efficient and should be used over Enum functions whenever possible, even if A.Vector implements the Enumerable and Collectable protocols for convienience:DON'TEnum.sum(vector) Enum.to_list(vector) Enum.reduce(vector, [], fun) Enum.into(enumerable, %A.Vector.new()) Enum.into(enumerable, vector)DOA.Vector.sum(vector) A.Vector.to_list(vector) A.Vector.foldl(vector, [], fun) A.Vector.new(enumerable) A.Vector.concat(vector, enumerable)for comprehensions are actually using Enumerable as well, so the same advice holds:DON'Tfor value &lt;- vector do do_stuff() endDOfor value &lt;- A.Vector.to_list(vector) do do_stuff() endExceptions: Enum optimized functionsEnum.member?/2 is implemented in an efficient way, so in/2 is optimal:DO33 in vectorEnum.slice/2 and Enum.slice/3 are optimized and their use is encouraged, other &quot;slicing&quot; functions like Enum.take/2 or Enum.drop/2 however are inefficient:DON'TEnum.take(vector, 10) Enum.drop(vector, 25)DOEnum.slice(vector, 0, 10) Enum.slice(vector, 0..10) Enum.slice(vector, 25..-1)Slicing optimizationSlicing any subset on the left on the vector using methods from A.Vector is extremely efficient as the vector internals can be reused:DOA.Vector.take(vector, 10) # take a positive amount A.Vector.drop(vector, -20) # drop a negative amount A.Vector.slice(vector, 0, 10) # slicing from 0 A.Vector.slice(vector, 0..-5) # slicing from 0A.Vector and Enum APIsNot all Enum functions have been mirrored in A.Vector, but you can try either to:use A.Vector.foldl/3 or A.Vector.foldr/3 to implement it (the latter is better to build lists)call A.Vector.to_list/1 before using EnumAlso, it is worth noting that several A.Vector functions return vectors, not lists like their Enum counterpart:iex&gt; vector = A.Vector.new(1..10) iex&gt; A.Vector.map(vector, &amp; (&amp;1 * 7)) #A&lt;vec([7, 14, 21, 28, 35, 42, 49, 56, 63, 70])&gt; iex&gt; A.Vector.reverse(vector) #A&lt;vec([10, 9, 8, 7, 6, 5, 4, 3, 2, 1])&gt;Additional notesIf you need to work with vectors containing mostly the same value, use A.Vector.duplicate/2 (more details in the Memory usage section).If you work with functions returning vectors of known size, you can use the A.vec/1 macro to defer the generation of the AST for the internal structure to compile time instead of runtime.A.Vector.new([a, 1, 2, 3, 4]) # structure created at runtime vec([a, 1, 2, 3, 4]) # structure AST defined at compile time","ref":"A.Vector.html","title":"A.Vector","type":"module"},{"doc":"Returns true if all elements in enumerable are truthy.Runs in linear time, but stops evaluating when finds the first falsy value.Iterates over the enumerable, and when it finds a falsy value (false or nil), false is returned. In all other cases true is returned.Examplesiex&gt; A.Vector.new([true, true, false]) |&gt; A.Vector.all?() false iex&gt; A.Vector.new([true, [], %{}, 5]) |&gt; A.Vector.all?() true iex&gt; A.Vector.new() |&gt; A.Vector.all?() true","ref":"A.Vector.html#all?/1","title":"A.Vector.all?/1","type":"function"},{"doc":"Returns true if fun.(element) is truthy for all elements in enumerable.Runs in linear time, but stops evaluating when finds the first falsy value.Iterates over the enumerable and invokes fun on each element. When an invocation of fun returns a falsy value (false or nil) iteration stops immediately and false is returned. In all other cases true is returned.Examplesiex&gt; vector = A.Vector.new(1..10) iex&gt; A.Vector.all?(vector, fn i -&gt; rem(i, 13) != 0 end) true iex&gt; A.Vector.all?(vector, fn i -&gt; rem(i, 7) != 0 end) false iex&gt; A.Vector.new() |&gt; A.Vector.all?(fn i -&gt; rem(i, 7) != 0 end) true","ref":"A.Vector.html#all?/2","title":"A.Vector.all?/2","type":"function"},{"doc":"Returns true if at least one element in enumerable is truthy.Runs in linear time, but stops evaluating when finds the first truthy value.Iterates over the enumerable, and when it finds a truthy value (neither false nor nil), true is returned. In all other cases false is returned.Examplesiex&gt; A.Vector.new([false, false, true]) |&gt; A.Vector.any?() true iex&gt; A.Vector.new([false, nil]) |&gt; A.Vector.any?() false iex&gt; A.Vector.new() |&gt; A.Vector.any?() false","ref":"A.Vector.html#any?/1","title":"A.Vector.any?/1","type":"function"},{"doc":"Returns true if fun.(element) is truthy for at least one element in enumerable.Runs in linear time, but stops evaluating when finds the first truthy value.Iterates over the enumerable and invokes fun on each element. When an invocation of fun returns a truthy value (neither false nor nil) iteration stops immediately and true is returned. In all other cases false is returned.Examplesiex&gt; vector = A.Vector.new(1..10) iex&gt; A.Vector.any?(vector, fn i -&gt; rem(i, 7) == 0 end) true iex&gt; A.Vector.any?(vector, fn i -&gt; rem(i, 13) == 0 end) false iex&gt; A.Vector.new() |&gt; A.Vector.any?(fn i -&gt; rem(i, 7) == 0 end) false","ref":"A.Vector.html#any?/2","title":"A.Vector.any?/2","type":"function"},{"doc":"Appends a value at the end of a vector.Runs in effective constant time.Examplesiex&gt; A.Vector.new() |&gt; A.Vector.append(:foo) #A&lt;vec([:foo])&gt; iex&gt; A.Vector.new(1..5) |&gt; A.Vector.append(:foo) #A&lt;vec([1, 2, 3, 4, 5, :foo])&gt;","ref":"A.Vector.html#append/2","title":"A.Vector.append/2","type":"function"},{"doc":"See A.Vector.concat/2.","ref":"A.Vector.html#append_many/2","title":"A.Vector.append_many/2","type":"function"},{"doc":"Finds the element at the given index (zero-based).Returns default if index is out of bounds. Supports negative indexing from the end of the vector.Runs in effective constant time.Examplesiex&gt; A.Vector.new(1..1_000) |&gt; A.Vector.at(555) 556 iex&gt; A.Vector.new(1..1_000) |&gt; A.Vector.at(1_000) nil","ref":"A.Vector.html#at/2","title":"A.Vector.at/2","type":"function"},{"doc":"","ref":"A.Vector.html#at/3","title":"A.Vector.at/3","type":"function"},{"doc":"Finds the element at the given index (zero-based).Raises an A.Vector.IndexError if index is out of bounds. Supports negative indexing from the end of the vector.Runs in effective constant time.Examplesiex&gt; A.Vector.new(1..1_000) |&gt; A.Vector.at!(555) 556 iex&gt; A.Vector.new(1..1_000) |&gt; A.Vector.at!(-10) 991 iex&gt; A.Vector.new(1..1_000) |&gt; A.Vector.at!(1_000) ** (A.Vector.IndexError) out of bound index: 1000 not in -1000..999","ref":"A.Vector.html#at!/2","title":"A.Vector.at!/2","type":"function"},{"doc":"Appends all values from an enumerable at the end of a vector.Runs in effective linear time in respect with the length of enumerable, disregarding the size of the vector.Examplesiex&gt; A.Vector.new(1..5) |&gt; A.Vector.concat(10..15) #A&lt;vec([1, 2, 3, 4, 5, 10, 11, 12, 13, 14, 15])&gt; iex&gt; A.Vector.new() |&gt; A.Vector.concat(10..15) #A&lt;vec([10, 11, 12, 13, 14, 15])&gt;","ref":"A.Vector.html#concat/2","title":"A.Vector.concat/2","type":"function"},{"doc":"Returns a copy of the vector where all consecutive duplicated elements are collapsed to a single element.Elements are compared using ===/2.If you want to remove all duplicated elements, regardless of order, see uniq/1.Examplesiex&gt; A.Vector.new([1, 2, 3, 3, 2, 1]) |&gt; A.Vector.dedup() #A&lt;vec([1, 2, 3, 2, 1])&gt; iex&gt; A.Vector.new([1, 1, 2, 2.0, :three, :three]) |&gt; A.Vector.dedup() #A&lt;vec([1, 2, 2.0, :three])&gt;","ref":"A.Vector.html#dedup/1","title":"A.Vector.dedup/1","type":"function"},{"doc":"Returns a copy of the vector where all consecutive duplicated elements are collapsed to a single element.The function fun maps every element to a term which is used to determine if two elements are duplicates.Examplesiex&gt; vector = A.Vector.new([{1, :a}, {2, :b}, {2, :c}, {1, :a}]) iex&gt; Enum.dedup_by(vector, fn {x, _} -&gt; x end) [{1, :a}, {2, :b}, {1, :a}] iex&gt; vector = A.Vector.new([5, 1, 2, 3, 2, 1]) iex&gt; Enum.dedup_by(vector, fn x -&gt; x &gt; 2 end) [5, 1, 3, 2]","ref":"A.Vector.html#dedup_by/2","title":"A.Vector.dedup_by/2","type":"function"},{"doc":"(Inefficient) Returns a copy of vector without the value at the specified index.Returns the vector untouched if index is out of bounds. Supports negative indexing from the end of the vector.Runs in linear time. Its usage is discouraged, see the Efficiency guide.Examplesiex&gt; vector = A.Vector.new(1..8) iex&gt; A.Vector.delete_at(vector, 4) #A&lt;vec([1, 2, 3, 4, 6, 7, 8])&gt; iex&gt; A.Vector.delete_at(vector, -9) #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8])&gt;","ref":"A.Vector.html#delete_at/2","title":"A.Vector.delete_at/2","type":"function"},{"doc":"(Inefficient) Returns a copy of vector without the value at the specified index.Raises an A.Vector.IndexError if index is out of bounds. Supports negative indexing from the end of the vector.Runs in linear time. Its usage is discouraged, see the Efficiency guide.Examplesiex&gt; vector = A.Vector.new(1..8) iex&gt; A.Vector.delete_at!(vector, 4) #A&lt;vec([1, 2, 3, 4, 6, 7, 8])&gt; iex&gt; A.Vector.delete_at!(vector, -9) ** (A.Vector.IndexError) out of bound index: -9 not in -8..7","ref":"A.Vector.html#delete_at!/2","title":"A.Vector.delete_at!/2","type":"function"},{"doc":"Removes the last value from the vector and returns the updated vector.Leaves the vector untouched if empty.Runs in effective constant time.Examplesiex&gt; vector = A.Vector.new(1..8) iex&gt; A.Vector.delete_last(vector) #A&lt;vec([1, 2, 3, 4, 5, 6, 7])&gt; iex&gt; A.Vector.delete_last(A.Vector.new()) #A&lt;vec([])&gt;","ref":"A.Vector.html#delete_last/1","title":"A.Vector.delete_last/1","type":"function"},{"doc":"Removes the last value from the vector and returns the updated vector.Raises an A.Vector.EmptyError if empty.Runs in effective constant time.Examplesiex&gt; vector = A.Vector.new(1..8) iex&gt; A.Vector.delete_last!(vector) #A&lt;vec([1, 2, 3, 4, 5, 6, 7])&gt; iex&gt; A.Vector.delete_last!(A.Vector.new()) ** (A.Vector.EmptyError) empty vector error","ref":"A.Vector.html#delete_last!/1","title":"A.Vector.delete_last!/1","type":"function"},{"doc":"Drops the amount of elements from the vector.If a negative amount is given, the amount of last values will be dropped.Time complexity is:linear when amount is positive, as the vector needs to be reconstructed.effective constant time when amount is negative, as the vector structure can be sharedExamplesiex&gt; A.Vector.new(0..15) |&gt; A.Vector.drop(10) #A&lt;vec([10, 11, 12, 13, 14, 15])&gt; iex&gt; A.Vector.new(0..5) |&gt; A.Vector.drop(0) #A&lt;vec([0, 1, 2, 3, 4, 5])&gt; iex&gt; A.Vector.new(0..10) |&gt; A.Vector.drop(-5) #A&lt;vec([0, 1, 2, 3, 4, 5])&gt;","ref":"A.Vector.html#drop/2","title":"A.Vector.drop/2","type":"function"},{"doc":"Drops elements at the beginning of the vector while fun returns a truthy value.Runs in linear time.Examplesiex&gt; A.Vector.new(1..10) |&gt; A.Vector.drop_while(fn x -&gt; x &lt; 7 end) #A&lt;vec([7, 8, 9, 10])&gt; iex&gt; A.Vector.new([1, true, %{}, nil, &quot;abc&quot;]) |&gt; A.Vector.drop_while(fn x -&gt; x end) #A&lt;vec([nil, &quot;abc&quot;])&gt;","ref":"A.Vector.html#drop_while/2","title":"A.Vector.drop_while/2","type":"function"},{"doc":"Duplicates the given element n times in a vector.n is an integer greater than or equal to 0. If n is 0, an empty list is returned.Runs in logarithmic time regarding n. It is very fast and memory efficient (see Memory usage).Examplesiex&gt; A.Vector.duplicate(nil, 10) #A&lt;vec([nil, nil, nil, nil, nil, nil, nil, nil, nil, nil])&gt; iex&gt; A.Vector.duplicate(:foo, 0) #A&lt;vec([])&gt;","ref":"A.Vector.html#duplicate/2","title":"A.Vector.duplicate/2","type":"function"},{"doc":"Invokes the given fun for each element in the vector.Returns :ok.Runs in linear time.ExamplesA.Vector.new(1..3) |&gt; A.Vector.each(&amp;IO.inspect/1) 1 2 3 :ok","ref":"A.Vector.html#each/2","title":"A.Vector.each/2","type":"function"},{"doc":"Finds the element at the given index (zero-based), and returns it in a ok-entry. If the index does not exist, returns :error.Supports negative indexing from the end of the vector.Runs in effective constant time.Examplesiex&gt; A.Vector.new(1..1_000) |&gt; A.Vector.fetch(555) {:ok, 556} iex&gt; A.Vector.new(1..1_000) |&gt; A.Vector.fetch(1_000) :error iex&gt; A.Vector.new(1..1_000) |&gt; A.Vector.fetch(-1) {:ok, 1000}","ref":"A.Vector.html#fetch/2","title":"A.Vector.fetch/2","type":"function"},{"doc":"See A.Vector.at!/2.","ref":"A.Vector.html#fetch!/2","title":"A.Vector.fetch!/2","type":"function"},{"doc":"Filters the vector, i.e. return a new vector containing only elements for which fun returns a truthy (neither false nor nil) value.Runs in linear time.Examplesiex&gt; vector = A.Vector.new(1..100) iex&gt; A.Vector.filter(vector, fn i -&gt; rem(i, 13) == 0 end) #A&lt;vec([13, 26, 39, 52, 65, 78, 91])&gt;","ref":"A.Vector.html#filter/2","title":"A.Vector.filter/2","type":"function"},{"doc":"Returns the first element of vector for which fun returns a truthy value (neither nil nor false).If no such element is found, returns default.Runs in linear time, but stops evaluating when finds the first truthy value.Examplesiex&gt; vector = A.Vector.new(2..10) iex&gt; A.Vector.find(vector, fn i -&gt; rem(49, i) == 0 end) 7 iex&gt; A.Vector.find(vector, fn i -&gt; rem(13, i) == 0 end) nil","ref":"A.Vector.html#find/3","title":"A.Vector.find/3","type":"function"},{"doc":"Similar to find/3, but returns the index (zero-based) of the element instead of the element itself.If no such element is found, returns nil.Runs in linear time, but stops evaluating when finds the first truthy value.Examplesiex&gt; vector = A.Vector.new([&quot;Ant&quot;, &quot;Bat&quot;, &quot;Cat&quot;, &quot;Dinosaur&quot;]) iex&gt; A.Vector.find_index(vector, fn s -&gt; String.first(s) == &quot;C&quot; end) 2 iex&gt; A.Vector.find_index(vector, fn s -&gt; String.first(s) == &quot;Z&quot; end) nil","ref":"A.Vector.html#find_index/2","title":"A.Vector.find_index/2","type":"function"},{"doc":"Similar to find/3, but returns the value of the function invocation instead of the element itself.The return value is considered to be found when the result is truthy (neither nil nor false).Runs in linear time, but stops evaluating when finds the first truthy value.Examplesiex&gt; vector = A.Vector.new([&quot;Ant&quot;, &quot;Bat&quot;, &quot;Cat&quot;, &quot;Dinosaur&quot;]) iex&gt; A.Vector.find_value(vector, fn s -&gt; String.at(s, 4) end) &quot;s&quot; iex&gt; A.Vector.find_value(vector, fn s -&gt; String.at(s, 10) end) nil","ref":"A.Vector.html#find_value/3","title":"A.Vector.find_value/3","type":"function"},{"doc":"Returns the first element in the vector or default if vector is empty.Runs in effective constant time.Examplesiex&gt; A.Vector.new(1..10_000) |&gt; A.Vector.first() 1 iex&gt; A.Vector.new() |&gt; A.Vector.first() nil","ref":"A.Vector.html#first/2","title":"A.Vector.first/2","type":"function"},{"doc":"Folds (reduces) the given vector from the left with the function fun. Requires an accumulator acc.Same as reduce/3.Runs in linear time.Examplesiex&gt; A.Vector.new(1..10) |&gt; A.Vector.foldl(0, &amp;+/2) 55 iex&gt; A.Vector.new(1..10) |&gt; A.Vector.foldl([], &amp; [&amp;1 | &amp;2]) [10, 9, 8, 7, 6, 5, 4, 3, 2, 1]","ref":"A.Vector.html#foldl/3","title":"A.Vector.foldl/3","type":"function"},{"doc":"Folds (reduces) the given vector from the right with the function fun. Requires an accumulator acc.Unlike linked lists, this is as efficient as foldl/3. This can typically save a call to Enum.reverse/1 on the result when building a list.Runs in linear time.Examplesiex&gt; A.Vector.new(1..10) |&gt; A.Vector.foldr(0, &amp;+/2) 55 iex&gt; A.Vector.new(1..10) |&gt; A.Vector.foldr([], &amp; [&amp;1 | &amp;2]) [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]","ref":"A.Vector.html#foldr/3","title":"A.Vector.foldr/3","type":"function"},{"doc":"Returns a map with keys as unique elements of vector and values as the count of every element.Examplesiex&gt; vector = A.Vector.new(~w{ant buffalo ant ant buffalo dingo}) iex&gt; A.Vector.frequencies(vector) %{&quot;ant&quot; =&gt; 3, &quot;buffalo&quot; =&gt; 2, &quot;dingo&quot; =&gt; 1}","ref":"A.Vector.html#frequencies/1","title":"A.Vector.frequencies/1","type":"function"},{"doc":"Returns a map with keys as unique elements given by key_fun and values as the count of every element from the vector.Examplesiex&gt; vector = A.Vector.new(~w{aa aA bb cc}) iex&gt; A.Vector.frequencies_by(vector, &amp;String.downcase/1) %{&quot;aa&quot; =&gt; 2, &quot;bb&quot; =&gt; 1, &quot;cc&quot; =&gt; 1} iex&gt; vector = A.Vector.new(~w{aaa aA bbb cc c}) iex&gt; A.Vector.frequencies_by(vector, &amp;String.length/1) %{3 =&gt; 2, 2 =&gt; 2, 1 =&gt; 1}","ref":"A.Vector.html#frequencies_by/2","title":"A.Vector.frequencies_by/2","type":"function"},{"doc":"Gets the value from key and updates it, all in one pass.See Access.get_and_update/3 for more details.Examplesiex&gt; vector = A.Vector.new(1..8) iex&gt; {6, updated} = A.Vector.get_and_update(vector, 5, fn current_value -&gt; ...&gt; {current_value, current_value &amp;&amp; current_value * 100} ...&gt; end); updated #A&lt;vec([1, 2, 3, 4, 5, 600, 7, 8])&gt; iex&gt; {nil, updated} = A.Vector.get_and_update(vector, 8, fn current_value -&gt; ...&gt; {current_value, current_value &amp;&amp; current_value * 100} ...&gt; end); updated #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8])&gt; iex&gt; {4, updated} = A.Vector.get_and_update(vector, 3, fn _ -&gt; :pop end); updated #A&lt;vec([1, 2, 3, 5, 6, 7, 8])&gt; iex&gt; {nil, updated} = A.Vector.get_and_update(vector, 8, fn _ -&gt; :pop end); updated #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8])&gt;","ref":"A.Vector.html#get_and_update/3","title":"A.Vector.get_and_update/3","type":"function"},{"doc":"Splits the vector into groups based on key_fun.The result is a map where each key is given by key_fun and each value is a list of elements given by value_fun.The order of elements within each list is preserved from the vector. However, like all maps, the resulting map is unordered.Examplesiex&gt; vector = A.Vector.new(~w{ant buffalo cat dingo}) iex&gt; A.Vector.group_by(vector, &amp;String.length/1) %{3 =&gt; [&quot;ant&quot;, &quot;cat&quot;], 5 =&gt; [&quot;dingo&quot;], 7 =&gt; [&quot;buffalo&quot;]} iex&gt; A.Vector.group_by(vector, &amp;String.length/1, &amp;String.first/1) %{3 =&gt; [&quot;a&quot;, &quot;c&quot;], 5 =&gt; [&quot;d&quot;], 7 =&gt; [&quot;b&quot;]}","ref":"A.Vector.html#group_by/3","title":"A.Vector.group_by/3","type":"function"},{"doc":"Intersperses separator between each element of the vector.Runs in linear time.Examplesiex&gt; A.Vector.new(1..6) |&gt; A.Vector.intersperse(nil) #A&lt;vec([1, nil, 2, nil, 3, nil, 4, nil, 5, nil, 6])&gt;","ref":"A.Vector.html#intersperse/2","title":"A.Vector.intersperse/2","type":"function"},{"doc":"Joins the given vector into a string using joiner as a separator.If joiner is not passed at all, it defaults to an empty string.All elements in the vector must be convertible to a string, otherwise an error is raised.Runs in linear time.Examplesiex&gt; A.Vector.new(1..6) |&gt; A.Vector.join() &quot;123456&quot; iex&gt; A.Vector.new(1..6) |&gt; A.Vector.join(&quot; + &quot;) &quot;1 + 2 + 3 + 4 + 5 + 6&quot; iex&gt; A.Vector.new() |&gt; A.Vector.join(&quot; + &quot;) &quot;&quot;","ref":"A.Vector.html#join/2","title":"A.Vector.join/2","type":"function"},{"doc":"Returns the last element in the vector or default if vector is empty.Runs in constant time (actual, not effective).Examplesiex&gt; A.Vector.new(1..10_000) |&gt; A.Vector.last() 10_000 iex&gt; A.Vector.new() |&gt; A.Vector.last() nil","ref":"A.Vector.html#last/2","title":"A.Vector.last/2","type":"function"},{"doc":"Returns a new vector where each element is the result of invoking fun on each corresponding element of vector.Runs in linear time.Examplesiex&gt; A.Vector.new(1..10) |&gt; A.Vector.map(&amp;(&amp;1 * &amp;1)) #A&lt;vec([1, 4, 9, 16, 25, 36, 49, 64, 81, 100])&gt;","ref":"A.Vector.html#map/2","title":"A.Vector.map/2","type":"function"},{"doc":"Maps and intersperses the vector in one pass.Runs in linear time.Examplesiex&gt; A.Vector.new(1..6) |&gt; A.Vector.map_intersperse(nil, &amp;(&amp;1 * 10)) #A&lt;vec([10, nil, 20, nil, 30, nil, 40, nil, 50, nil, 60])&gt;","ref":"A.Vector.html#map_intersperse/3","title":"A.Vector.map_intersperse/3","type":"function"},{"doc":"Maps and joins the given vector into a string using joiner as a separator.If joiner is not passed at all, it defaults to an empty string.mapper should only return values that are convertible to a string, otherwise an error is raised.Runs in linear time.Examplesiex&gt; A.Vector.new(1..6) |&gt; A.Vector.map_join(fn x -&gt; x * 10 end) &quot;102030405060&quot; iex&gt; A.Vector.new(1..6) |&gt; A.Vector.map_join(&quot; + &quot;, fn x -&gt; x * 10 end) &quot;10 + 20 + 30 + 40 + 50 + 60&quot; iex&gt; A.Vector.new() |&gt; A.Vector.map_join(&quot; + &quot;, fn x -&gt; x * 10 end) &quot;&quot;","ref":"A.Vector.html#map_join/3","title":"A.Vector.map_join/3","type":"function"},{"doc":"Invokes the given fun to each element in the vector to reduce it to a single element, while keeping an accumulator.Returns a tuple where the first element is the mapped vector and the second one is the final accumulator.The function, fun, receives two arguments: the first one is the element, and the second one is the accumulator. fun must return a tuple with two elements in the form of {result, accumulator}.Examplesiex&gt; vector = A.Vector.new([1, 2, 3]) iex&gt; {new_vec, 6} = A.Vector.map_reduce(vector, 0, fn x, acc -&gt; {x * 2, x + acc} end) iex&gt; new_vec #A&lt;vec([2, 4, 6])&gt;For example, if with_index/2 was not implemented, you could implement it as follows:iex&gt; vector = A.Vector.new([1, 2, 3]) iex&gt; {new_vec, _} = A.Vector.map_reduce(vector, 0, fn x, i -&gt; {{x, i}, i + 1} end); new_vec #A&lt;vec([{1, 0}, {2, 1}, {3, 2}])&gt;","ref":"A.Vector.html#map_reduce/3","title":"A.Vector.map_reduce/3","type":"function"},{"doc":"Returns the maximal element in the vector according to Erlang's term ordering.If multiple elements are considered maximal, the first one that was found is returned.Raises a A.Vector.EmptyError if empty.Runs in linear time.Examplesiex&gt; A.Vector.new(1..10) |&gt; A.Vector.max() 10 iex&gt; A.Vector.new() |&gt; A.Vector.max() ** (A.Vector.EmptyError) empty vector error","ref":"A.Vector.html#max/1","title":"A.Vector.max/1","type":"function"},{"doc":"Returns the maximal element in the vector using sorter to compare elements.sorter can either be an arity-2 function returning a boolean or a module implementing a compare/2 function, such as Date.compare/2.See documentation for Enum.max/3 for more explanations.Raises a A.Vector.EmptyError if empty.Runs in linear time.Examplesiex&gt; A.Vector.new([~D[2017-03-31], ~D[2017-04-01]]) |&gt; A.Vector.max() ~D[2017-03-31] iex&gt; A.Vector.new([~D[2017-03-31], ~D[2017-04-01]]) |&gt; A.Vector.max(Date) ~D[2017-04-01] iex&gt; A.Vector.new() |&gt; A.Vector.max(Date) ** (A.Vector.EmptyError) empty vector error","ref":"A.Vector.html#max/2","title":"A.Vector.max/2","type":"function"},{"doc":"Returns the maximal element in the vector as calculated by the given fun.By default, the comparison is done with the &gt;= sorter function. If multiple elements are considered maximal, the first one that was found is returned. If you want the last element considered maximal to be returned, the sorter function should not return true for equal elements.Raises a A.Vector.EmptyError if empty.Runs in linear time.Examplesiex&gt; A.Vector.new([&quot;a&quot;, &quot;aa&quot;, &quot;aaa&quot;]) |&gt; A.Vector.max_by(&amp;String.length/1) &quot;aaa&quot; iex&gt; A.Vector.new([&quot;a&quot;, &quot;aa&quot;, &quot;aaa&quot;, &quot;b&quot;, &quot;bbb&quot;]) |&gt; A.Vector.max_by(&amp;String.length/1) &quot;aaa&quot; iex&gt; A.Vector.new([]) |&gt; A.Vector.max_by(&amp;String.length/1) ** (ArgumentError) argument errorThe fact this function uses Erlang's term ordering means that the comparison is structural and not semantic. Therefore, if you want to compare structs, most structs provide a &quot;compare&quot; function, such as Date.compare/2, which receives two structs and returns :lt (less-than), :eq (equal to), and :gt (greater-than). If you pass a module as the sorting function, Elixir will automatically use the compare/2 function of said module:iex&gt; users = A.Vector.new([ ...&gt; %{name: &quot;Ellis&quot;, birthday: ~D[1943-05-11]}, ...&gt; %{name: &quot;Lovelace&quot;, birthday: ~D[1815-12-10]}, ...&gt; %{name: &quot;Turing&quot;, birthday: ~D[1912-06-23]} ...&gt; ]) iex&gt; A.Vector.max_by(users, &amp;(&amp;1.birthday), Date) %{name: &quot;Ellis&quot;, birthday: ~D[1943-05-11]}","ref":"A.Vector.html#max_by/3","title":"A.Vector.max_by/3","type":"function"},{"doc":"Returns the minimal element in the vector according to Erlang's term ordering.If multiple elements are considered minimal, the first one that was found is returned.Raises a A.Vector.EmptyError if empty.Runs in linear time.Examplesiex&gt; A.Vector.new(1..10) |&gt; A.Vector.min() 1 iex&gt; A.Vector.new() |&gt; A.Vector.min() ** (A.Vector.EmptyError) empty vector error","ref":"A.Vector.html#min/1","title":"A.Vector.min/1","type":"function"},{"doc":"Returns the minimal element in the vector using sorter to compare elements.sorter can either be an arity-2 function returning a boolean or a module implementing a compare/2 function, such as Date.compare/2.See documentation for Enum.min/3 for more explanations.Raises a A.Vector.EmptyError if empty.Runs in linear time.Examplesiex&gt; A.Vector.new([~D[2017-03-31], ~D[2017-04-01]]) |&gt; A.Vector.min() ~D[2017-04-01] iex&gt; A.Vector.new([~D[2017-03-31], ~D[2017-04-01]]) |&gt; A.Vector.min(Date) ~D[2017-03-31] iex&gt; A.Vector.new() |&gt; A.Vector.min(Date) ** (A.Vector.EmptyError) empty vector error","ref":"A.Vector.html#min/2","title":"A.Vector.min/2","type":"function"},{"doc":"Returns the minimal element in the vector as calculated by the given fun.By default, the comparison is done with the &lt;= sorter function. If multiple elements are considered minimal, the first one that was found is returned. If you want the last element considered minimal to be returned, the sorter function should not return true for equal elements.Raises a A.Vector.EmptyError if empty.Runs in linear time.Examplesiex&gt; A.Vector.new([&quot;a&quot;, &quot;aa&quot;, &quot;aaa&quot;]) |&gt; A.Vector.min_by(&amp;String.length/1) &quot;a&quot; iex&gt; A.Vector.new([&quot;a&quot;, &quot;aa&quot;, &quot;aaa&quot;, &quot;b&quot;, &quot;bbb&quot;]) |&gt; A.Vector.min_by(&amp;String.length/1) &quot;a&quot; iex&gt; A.Vector.new([]) |&gt; A.Vector.min_by(&amp;String.length/1) ** (ArgumentError) argument errorThe fact this function uses Erlang's term ordering means that the comparison is structural and not semantic. Therefore, if you want to compare structs, most structs provide a &quot;compare&quot; function, such as Date.compare/2, which receives two structs and returns :lt (less-than), :eq (equal to), and :gt (greater-than). If you pass a module as the sorting function, Elixir will automatically use the compare/2 function of said module:iex&gt; users = A.Vector.new([ ...&gt; %{name: &quot;Ellis&quot;, birthday: ~D[1943-05-11]}, ...&gt; %{name: &quot;Lovelace&quot;, birthday: ~D[1815-12-10]}, ...&gt; %{name: &quot;Turing&quot;, birthday: ~D[1912-06-23]} ...&gt; ]) iex&gt; A.Vector.min_by(users, &amp;(&amp;1.birthday), Date) %{name: &quot;Lovelace&quot;, birthday: ~D[1815-12-10]}","ref":"A.Vector.html#min_by/3","title":"A.Vector.min_by/3","type":"function"},{"doc":"Returns a new empty vector.Examplesiex&gt; A.Vector.new() #A&lt;vec([])&gt;","ref":"A.Vector.html#new/0","title":"A.Vector.new/0","type":"function"},{"doc":"Creates a vector from an enumerable.Runs in linear time.Examplesiex&gt; A.Vector.new(10..25) #A&lt;vec([10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25])&gt;","ref":"A.Vector.html#new/1","title":"A.Vector.new/1","type":"function"},{"doc":"Creates a vector from an enumerable via the given transform function.Examplesiex&gt; A.Vector.new(1..10, &amp;(&amp;1 * &amp;1)) #A&lt;vec([1, 4, 9, 16, 25, 36, 49, 64, 81, 100])&gt;","ref":"A.Vector.html#new/2","title":"A.Vector.new/2","type":"function"},{"doc":"(Inefficient) Returns and removes the value at the specified index in the vector.Returns the vector untouched if index is out of bounds. Supports negative indexing from the end of the vector.Runs in linear time. Its usage is discouraged, see the Efficiency guide.Examplesiex&gt; vector = A.Vector.new(1..8) iex&gt; {5, updated} = A.Vector.pop_at(vector, 4); updated #A&lt;vec([1, 2, 3, 4, 6, 7, 8])&gt; iex&gt; {nil, updated} = A.Vector.pop_at(vector, -9); updated #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8])&gt;","ref":"A.Vector.html#pop_at/3","title":"A.Vector.pop_at/3","type":"function"},{"doc":"(Inefficient) Returns and removes the value at the specified index in the vector.Raises an A.Vector.IndexError if index is out of bounds. Supports negative indexing from the end of the vector.Runs in linear time. Its usage is discouraged, see the Efficiency guide.Examplesiex&gt; vector = A.Vector.new(1..8) iex&gt; {5, updated} = A.Vector.pop_at!(vector, 4); updated #A&lt;vec([1, 2, 3, 4, 6, 7, 8])&gt; iex&gt; A.Vector.pop_at!(vector, -9) ** (A.Vector.IndexError) out of bound index: -9 not in -8..7","ref":"A.Vector.html#pop_at!/2","title":"A.Vector.pop_at!/2","type":"function"},{"doc":"Removes the last value from the vector and returns both the value and the updated vector.Leaves the vector untouched if empty.Runs in effective constant time.Examplesiex&gt; vector = A.Vector.new(1..8) iex&gt; {8, updated} = A.Vector.pop_last(vector); updated #A&lt;vec([1, 2, 3, 4, 5, 6, 7])&gt; iex&gt; {nil, updated} = A.Vector.pop_last(A.Vector.new()); updated #A&lt;vec([])&gt;","ref":"A.Vector.html#pop_last/2","title":"A.Vector.pop_last/2","type":"function"},{"doc":"Removes the last value from the vector and returns both the value and the updated vector.Raises an A.Vector.EmptyError if empty.Runs in effective constant time.Examplesiex&gt; vector = A.Vector.new(1..8) iex&gt; {8, updated} = A.Vector.pop_last!(vector); updated #A&lt;vec([1, 2, 3, 4, 5, 6, 7])&gt; iex&gt; {nil, updated} = A.Vector.pop_last!(A.Vector.new()); updated ** (A.Vector.EmptyError) empty vector error","ref":"A.Vector.html#pop_last!/1","title":"A.Vector.pop_last!/1","type":"function"},{"doc":"(Inefficient) Prepends value at the beginning of the vector.Runs in linear time because the whole vector needs to be reconstructuded, and should be avoided.Examplesiex&gt; A.Vector.new() |&gt; A.Vector.prepend(:foo) #A&lt;vec([:foo])&gt; iex&gt; A.Vector.new(1..5) |&gt; A.Vector.prepend(:foo) #A&lt;vec([:foo, 1, 2, 3, 4, 5])&gt;","ref":"A.Vector.html#prepend/2","title":"A.Vector.prepend/2","type":"function"},{"doc":"Returns the product of all elements in the vector.Raises ArithmeticError if vector contains a non-numeric value.Runs in linear time.Examplesiex&gt; A.Vector.new(1..5) |&gt; A.Vector.product() 120 iex&gt; A.Vector.new() |&gt; A.Vector.product() 1","ref":"A.Vector.html#product/1","title":"A.Vector.product/1","type":"function"},{"doc":"Returns a random element of a vector.Raises Vector.EmptyError if vector is empty.Like Enum.random/1, this function uses Erlang's :rand module to calculate the random value. Check its documentation for setting a different random algorithm or a different seed.Runs in effective constant time, and is therefore more efficient than Enum.random/1 on lists.Examples# Although not necessary, let&#39;s seed the random algorithm iex&gt;:rand.seed(:exrop, {101, 102, 103}) iex&gt; A.Vector.new([1, 2, 3]) |&gt; A.Vector.random() 3 iex&gt; A.Vector.new([1, 2, 3]) |&gt; A.Vector.random() 2 iex&gt; A.Vector.new(1..1_000) |&gt; A.Vector.random() 846 iex&gt; A.Vector.new([]) |&gt; A.Vector.random() ** (A.Vector.EmptyError) empty vector error","ref":"A.Vector.html#random/1","title":"A.Vector.random/1","type":"function"},{"doc":"Invokes fun for each element in the vector with the accumulator.Raises A.Vector.EmptyError if vector is empty.The first element of the vector is used as the initial value of the accumulator. Then the function is invoked with the next element and the accumulator. The result returned by the function is used as the accumulator for the next iteration, recursively.Since the first element of the vector is used as the initial value of the accumulator, fun will only be executed n - 1 times where n is the size of the vector. This function won't call the specified function if vector only has one element.If you wish to use another value for the accumulator, use reduce/3.Runs in linear time.Examplesiex&gt; A.Vector.new([1, 2, 3, 4, 5]) |&gt; A.Vector.reduce(fn x, acc -&gt; x * acc end) 120 iex&gt; A.Vector.new([]) |&gt; A.Vector.reduce(fn x, acc -&gt; x * acc end) ** (A.Vector.EmptyError) empty vector error","ref":"A.Vector.html#reduce/2","title":"A.Vector.reduce/2","type":"function"},{"doc":"Folds (reduces) the given vector from the left with the function fun. Requires an accumulator acc.Same as foldl/3.Runs in linear time.Examplesiex&gt; A.Vector.new(1..10) |&gt; A.Vector.reduce(0, &amp;+/2) 55 iex&gt; A.Vector.new(1..10) |&gt; A.Vector.reduce([], &amp; [&amp;1 | &amp;2]) [10, 9, 8, 7, 6, 5, 4, 3, 2, 1]","ref":"A.Vector.html#reduce/3","title":"A.Vector.reduce/3","type":"function"},{"doc":"Filters the vector, i.e. return a new vector containing only elements for which fun returns a falsy (either false or nil) value.Runs in linear time.Examplesiex&gt; vector = A.Vector.new(1..12) iex&gt; A.Vector.reject(vector, fn i -&gt; rem(i, 3) == 0 end) #A&lt;vec([1, 2, 4, 5, 7, 8, 10, 11])&gt;","ref":"A.Vector.html#reject/2","title":"A.Vector.reject/2","type":"function"},{"doc":"Populates a vector of size n by calling generator_fun repeatedly.Examples# Although not necessary, let&#39;s seed the random algorithm iex&gt; :rand.seed(:exsplus, {1, 2, 3}) iex&gt; A.Vector.repeatedly(&amp;:rand.uniform/0, 3) #A&lt;vec([0.40502929729990744, 0.45336720247823126, 0.04094511692041057])&gt;","ref":"A.Vector.html#repeatedly/2","title":"A.Vector.repeatedly/2","type":"function"},{"doc":"Returns a copy of vector with a replaced value at the specified index.Returns the vector untouched if index is out of bounds. Supports negative indexing from the end of the vector.Runs in effective constant time.Examplesiex&gt; A.Vector.new(1..8) |&gt; A.Vector.replace_at(5, :foo) #A&lt;vec([1, 2, 3, 4, 5, :foo, 7, 8])&gt; iex&gt; A.Vector.new(1..8) |&gt; A.Vector.replace_at(8, :foo) #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8])&gt; iex&gt; A.Vector.new(1..8) |&gt; A.Vector.replace_at(-2, :foo) #A&lt;vec([1, 2, 3, 4, 5, 6, :foo, 8])&gt;","ref":"A.Vector.html#replace_at/3","title":"A.Vector.replace_at/3","type":"function"},{"doc":"Returns a copy of vector with a replaced value at the specified index.Raises an A.Vector.IndexError if index is out of bounds. Supports negative indexing from the end of the vector.Runs in effective constant time.Examplesiex&gt; A.Vector.new(1..8) |&gt; A.Vector.replace_at!(5, :foo) #A&lt;vec([1, 2, 3, 4, 5, :foo, 7, 8])&gt; iex&gt; A.Vector.new(1..8) |&gt; A.Vector.replace_at!(-2, :foo) #A&lt;vec([1, 2, 3, 4, 5, 6, :foo, 8])&gt; iex&gt; A.Vector.new(1..8) |&gt; A.Vector.replace_at!(8, :foo) ** (A.Vector.IndexError) out of bound index: 8 not in -8..7","ref":"A.Vector.html#replace_at!/3","title":"A.Vector.replace_at!/3","type":"function"},{"doc":"Returns the vector in reverse order.Runs in linear time.Examplesiex&gt; A.Vector.new(1..12) |&gt; A.Vector.reverse() #A&lt;vec([12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1])&gt;","ref":"A.Vector.html#reverse/1","title":"A.Vector.reverse/1","type":"function"},{"doc":"Applies the given function to each element in the vector, storing the result in a vector and passing it as the accumulator for the next computation.Uses the first element in the vector as the starting value.Runs in linear time.Examplesiex&gt; A.Vector.new(1..10) |&gt; A.Vector.scan(&amp;+/2) #A&lt;vec([1, 3, 6, 10, 15, 21, 28, 36, 45, 55])&gt;","ref":"A.Vector.html#scan/2","title":"A.Vector.scan/2","type":"function"},{"doc":"Applies the given function to each element in the vector, storing the result in a vector and passing it as the accumulator for the next computation.Uses the given acc as the starting value.Runs in linear time.Examplesiex&gt; A.Vector.new(1..10) |&gt; A.Vector.scan(100, &amp;+/2) #A&lt;vec([101, 103, 106, 110, 115, 121, 128, 136, 145, 155])&gt;","ref":"A.Vector.html#scan/3","title":"A.Vector.scan/3","type":"function"},{"doc":"Returns a new vector with the elements of vector shuffled.See Enum.shuffle/1 for notes on implementation and random seed.Examples# Although not necessary, let&#39;s seed the random algorithm iex&gt; :rand.seed(:exrop, {1, 2, 3}) iex&gt; A.Vector.new([1, 2, 3]) |&gt; A.Vector.shuffle() #A&lt;vec([3, 1, 2])&gt; iex&gt; A.Vector.new([1, 2, 3]) |&gt; A.Vector.shuffle() #A&lt;vec([1, 3, 2])&gt;","ref":"A.Vector.html#shuffle/1","title":"A.Vector.shuffle/1","type":"function"},{"doc":"Returns the number of elements in vector.Runs in constant time.Examplesiex&gt; A.Vector.new(10_000..20_000) |&gt; A.Vector.size() 10001 iex&gt; A.Vector.new() |&gt; A.Vector.size() 0","ref":"A.Vector.html#size/1","title":"A.Vector.size/1","type":"function"},{"doc":"Returns a subset of the given vector by index_range.Works the same as Enum.slice/2, see its documentation for more details.Runs in linear time regarding the size of the returned subset.Examplesiex&gt; A.Vector.new(0..100) |&gt; A.Vector.slice(80..90) #A&lt;vec([80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90])&gt; iex&gt; A.Vector.new(0..100) |&gt; A.Vector.slice(-40..-30) #A&lt;vec([61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71])&gt; iex&gt; A.Vector.new([:only_one]) |&gt; A.Vector.slice(0..1000) #A&lt;vec([:only_one])&gt;","ref":"A.Vector.html#slice/2","title":"A.Vector.slice/2","type":"function"},{"doc":"Returns a subset of the given vector, from start_index (zero-based) with amount number of elements if available.Works the same as Enum.slice/3, see its documentation for more details.Runs in linear time regarding the size of the returned subset.Examplesiex&gt; A.Vector.new(0..100) |&gt; A.Vector.slice(80, 10) #A&lt;vec([80, 81, 82, 83, 84, 85, 86, 87, 88, 89])&gt; iex&gt; A.Vector.new(0..100) |&gt; A.Vector.slice(-40, 10) #A&lt;vec([61, 62, 63, 64, 65, 66, 67, 68, 69, 70])&gt; iex&gt; A.Vector.new([:only_one]) |&gt; A.Vector.slice(0, 1000) #A&lt;vec([:only_one])&gt;","ref":"A.Vector.html#slice/3","title":"A.Vector.slice/3","type":"function"},{"doc":"Sorts the vector in the same way as Enum.sort/1.Examplesiex&gt; A.Vector.new(9..1) |&gt; A.Vector.sort() #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8, 9])&gt;","ref":"A.Vector.html#sort/1","title":"A.Vector.sort/1","type":"function"},{"doc":"Sorts the vector in the same way as Enum.sort/2.See Enum.sort/2 documentation for detailled usage.Examplesiex&gt; A.Vector.new(1..9) |&gt; A.Vector.sort(:desc) #A&lt;vec([9, 8, 7, 6, 5, 4, 3, 2, 1])&gt;","ref":"A.Vector.html#sort/2","title":"A.Vector.sort/2","type":"function"},{"doc":"Sorts the vector in the same way as Enum.sort_by/3.See Enum.sort_by/3 documentation for detailled usage.Examplesiex&gt; vector = A.Vector.new([&quot;some&quot;, &quot;kind&quot;, &quot;of&quot;, &quot;monster&quot;]) iex&gt; A.Vector.sort_by(vector, &amp;byte_size/1) #A&lt;vec([&quot;of&quot;, &quot;some&quot;, &quot;kind&quot;, &quot;monster&quot;])&gt; iex&gt; A.Vector.sort_by(vector, &amp;{byte_size(&amp;1), String.first(&amp;1)}) #A&lt;vec([&quot;of&quot;, &quot;kind&quot;, &quot;some&quot;, &quot;monster&quot;])&gt;","ref":"A.Vector.html#sort_by/3","title":"A.Vector.sort_by/3","type":"function"},{"doc":"Splits the vector into two vectors, leaving amount elements in the first one.If amount is a negative number, it starts counting from the back to the beginning of the vector.Runs in linear time.Examplesiex&gt; vector = A.Vector.new([1, 2, 3]) iex&gt; A.Vector.split(vector, 2) |&gt; inspect() &quot;{#A&lt;vec([1, 2])&gt;, #A&lt;vec([3])&gt;}&quot; iex&gt; A.Vector.split(vector, 10) |&gt; inspect() &quot;{#A&lt;vec([1, 2, 3])&gt;, #A&lt;vec([])&gt;}&quot; iex&gt; A.Vector.split(vector, 0) |&gt; inspect() &quot;{#A&lt;vec([])&gt;, #A&lt;vec([1, 2, 3])&gt;}&quot; iex&gt; A.Vector.split(vector, -1) |&gt; inspect() &quot;{#A&lt;vec([1, 2])&gt;, #A&lt;vec([3])&gt;}&quot; iex&gt; A.Vector.split(vector, -5) |&gt; inspect() &quot;{#A&lt;vec([])&gt;, #A&lt;vec([1, 2, 3])&gt;}&quot;","ref":"A.Vector.html#split/2","title":"A.Vector.split/2","type":"function"},{"doc":"Splits vector in two at the position of the element for which fun returns a falsy value (false or nil) for the first time.It returns a two-element tuple with two vectors of elements. The element that triggered the split is part of the second vector.Is basically performing take_while/2 and drop_while/2 at once.Runs in linear time.Examplesiex&gt; {taken, dropped} = A.Vector.new(1..10) |&gt; A.Vector.split_while(fn x -&gt; x &lt; 7 end) iex&gt; taken #A&lt;vec([1, 2, 3, 4, 5, 6])&gt; iex&gt; dropped #A&lt;vec([7, 8, 9, 10])&gt;","ref":"A.Vector.html#split_while/2","title":"A.Vector.split_while/2","type":"function"},{"doc":"Splits the vector in two vectors according to the given function fun.Returns a tuple with the first vector containing all the elements in vector for which applying fun returned a truthy value, and a second vector with all the elements for which applying fun returned a falsy value (false or nil).Returns the same result as filter/2 and reject/2 at once, but only walks the vector once and calls fun exactly once per element.Runs in linear time.Examplesiex&gt; vector = A.Vector.new(1..12) iex&gt; {filtered, rejected} = A.Vector.split_with(vector, fn i -&gt; rem(i, 3) == 0 end) iex&gt; filtered #A&lt;vec([3, 6, 9, 12])&gt; iex&gt; rejected #A&lt;vec([1, 2, 4, 5, 7, 8, 10, 11])&gt;","ref":"A.Vector.html#split_with/2","title":"A.Vector.split_with/2","type":"function"},{"doc":"Returns the sum of all elements in the vector.Raises ArithmeticError if vector contains a non-numeric value.Runs in linear time.Examplesiex&gt; A.Vector.new(1..10) |&gt; A.Vector.sum() 55 iex&gt; A.Vector.new() |&gt; A.Vector.sum() 0","ref":"A.Vector.html#sum/1","title":"A.Vector.sum/1","type":"function"},{"doc":"Takes an amount of elements from the beginning or the end of the vector.If a positive amount is given, it takes the amount elements from the beginning of the vector.If a negative amount is given, the amount of elements will be taken from the end.If amount is 0, it returns the empty vector.Time complexity is:effective constant time when amount is positive, as the vector structure can be sharedlinear when amount is negative, as the vector needs to be reconstructed.Examplesiex&gt; A.Vector.new(0..100) |&gt; A.Vector.take(10) #A&lt;vec([0, 1, 2, 3, 4, 5, 6, 7, 8, 9])&gt; iex&gt; A.Vector.new([:only_one]) |&gt; A.Vector.take(1000) #A&lt;vec([:only_one])&gt; iex&gt; A.Vector.new(0..10) |&gt; A.Vector.take(-5) #A&lt;vec([6, 7, 8, 9, 10])&gt;","ref":"A.Vector.html#take/2","title":"A.Vector.take/2","type":"function"},{"doc":"Takes amount random elements from vector.Note that, unless amount is 0 or 1, this function will traverse the whole vector to get the random sub-vector.If amount is more than the vector size, this is equivalent to shuffling the vector: the returned vector cannot be bigger than the original one.See Enum.random/1 for notes on implementation and random seed.Runs in linear time (except for amount &lt;= 1, which is effective constant time).Examples# Although not necessary, let&#39;s seed the random algorithm iex&gt; :rand.seed(:exrop, {1, 2, 3}) iex&gt; A.Vector.new(1..10) |&gt; A.Vector.take_random(2) #A&lt;vec([7, 2])&gt; iex&gt; A.Vector.new([:foo, :bar, :baz]) |&gt; A.Vector.take_random(100) #A&lt;vec([:bar, :baz, :foo])&gt;","ref":"A.Vector.html#take_random/2","title":"A.Vector.take_random/2","type":"function"},{"doc":"Takes the elements from the beginning of the vector while fun returns a truthy value.Runs in linear time regarding the size of the returned subset.Examplesiex&gt; A.Vector.new(1..100) |&gt; A.Vector.take_while(fn x -&gt; x &lt; 7 end) #A&lt;vec([1, 2, 3, 4, 5, 6])&gt; iex&gt; A.Vector.new([1, true, %{}, nil, &quot;abc&quot;]) |&gt; A.Vector.take_while(fn x -&gt; x end) #A&lt;vec([1, true, %{}])&gt;","ref":"A.Vector.html#take_while/2","title":"A.Vector.take_while/2","type":"function"},{"doc":"Converts the vector to a list.Runs in linear time.Examplesiex&gt; A.Vector.new(10..25) |&gt; A.Vector.to_list() [10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25] iex&gt; A.Vector.new() |&gt; A.Vector.to_list() []","ref":"A.Vector.html#to_list/1","title":"A.Vector.to_list/1","type":"function"},{"doc":"Returns a copy of the vector without any duplicated element.The first occurrence of each element is kept.Examplesiex&gt; A.Vector.new([1, 1, 2, 1, 2, 3, 2]) |&gt; A.Vector.uniq() #A&lt;vec([1, 2, 3])&gt;","ref":"A.Vector.html#uniq/1","title":"A.Vector.uniq/1","type":"function"},{"doc":"Returns a copy of the vector without elements for which the function fun returned duplicate elements.The first occurrence of each element is kept.Examplesiex&gt; vector = A.Vector.new([x: 1, y: 2, z: 1]) #A&lt;vec([x: 1, y: 2, z: 1])&gt; iex&gt; A.Vector.uniq_by(vector, fn {_x, y} -&gt; y end) #A&lt;vec([x: 1, y: 2])&gt;","ref":"A.Vector.html#uniq_by/2","title":"A.Vector.uniq_by/2","type":"function"},{"doc":"Opposite of zip/2. Extracts two-element tuples from the given vector and groups them together.It takes a vector with elements being two-element tuples and returns a tuple with two vectors, each of which is formed by the first and second element of each tuple, respectively.This function fails unless vector only contains tuples with exactly two elements in each tuple.Runs in linear time.iex&gt; {vector1, vector2} = A.Vector.new([{1, :a}, {2, :b}, {3, :c}]) |&gt; A.Vector.unzip() iex&gt; vector1 #A&lt;vec([1, 2, 3])&gt; iex&gt; vector2 #A&lt;vec([:a, :b, :c])&gt;","ref":"A.Vector.html#unzip/1","title":"A.Vector.unzip/1","type":"function"},{"doc":"Returns a copy of vector with an updated value at the specified index.Returns the vector untouched if index is out of bounds. Supports negative indexing from the end of the vector.Runs in effective constant time.Examplesiex&gt; A.Vector.new(1..8) |&gt; A.Vector.update_at(2, &amp;(&amp;1 * 1000)) #A&lt;vec([1, 2, 3000, 4, 5, 6, 7, 8])&gt; iex&gt; A.Vector.new(1..8) |&gt; A.Vector.update_at(8, &amp;(&amp;1 * 1000)) #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8])&gt; iex&gt; A.Vector.new(1..8) |&gt; A.Vector.update_at(-1, &amp;(&amp;1 * 1000)) #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8000])&gt;","ref":"A.Vector.html#update_at/3","title":"A.Vector.update_at/3","type":"function"},{"doc":"Returns a copy of vector with an updated value at the specified index.Raises an A.Vector.IndexError if index is out of bounds. Supports negative indexing from the end of the vector.Runs in effective constant time.Examplesiex&gt; A.Vector.new(1..8) |&gt; A.Vector.update_at!(2, &amp;(&amp;1 * 1000)) #A&lt;vec([1, 2, 3000, 4, 5, 6, 7, 8])&gt; iex&gt; A.Vector.new(1..8) |&gt; A.Vector.update_at!(-1, &amp;(&amp;1 * 1000)) #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8000])&gt; iex&gt; A.Vector.new(1..8) |&gt; A.Vector.update_at!(-9, &amp;(&amp;1 * 1000)) ** (A.Vector.IndexError) out of bound index: -9 not in -8..7","ref":"A.Vector.html#update_at!/3","title":"A.Vector.update_at!/3","type":"function"},{"doc":"Returns the vector with each element wrapped in a tuple alongside its index.If an integer offset is given, it will index from the given offset instead of from zero.If a function is given, it will index by invoking the function for each element and index (zero-based) of the vector.Runs in linear time.Examplesiex&gt; vector = A.Vector.new([&quot;foo&quot;, &quot;bar&quot;, &quot;baz&quot;]) iex&gt; A.Vector.with_index(vector) #A&lt;vec([{&quot;foo&quot;, 0}, {&quot;bar&quot;, 1}, {&quot;baz&quot;, 2}])&gt; iex&gt; A.Vector.with_index(vector, 100) #A&lt;vec([{&quot;foo&quot;, 100}, {&quot;bar&quot;, 101}, {&quot;baz&quot;, 102}])&gt; iex&gt; A.Vector.with_index(vector, fn element, index -&gt; {index, element} end) #A&lt;vec([{0, &quot;foo&quot;}, {1, &quot;bar&quot;}, {2, &quot;baz&quot;}])&gt;","ref":"A.Vector.html#with_index/2","title":"A.Vector.with_index/2","type":"function"},{"doc":"Zips corresponding elements from two vectors into one vector of tuples.The size of the returned vector is the one of the smallest of the input vectors.Runs in linear time.iex&gt; A.Vector.zip(A.Vector.new([1, 2, 3]), A.Vector.new([:a, :b, :c])) #A&lt;vec([{1, :a}, {2, :b}, {3, :c}])&gt; iex&gt; A.Vector.zip(A.Vector.new(0..100), A.Vector.new([:a, :b, :c])) #A&lt;vec([{0, :a}, {1, :b}, {2, :c}])&gt;","ref":"A.Vector.html#zip/2","title":"A.Vector.zip/2","type":"function"},{"doc":"","ref":"A.Vector.html#t:index/0","title":"A.Vector.index/0","type":"type"},{"doc":"","ref":"A.Vector.html#t:t/0","title":"A.Vector.t/0","type":"type"},{"doc":"","ref":"A.Vector.html#t:t/1","title":"A.Vector.t/1","type":"opaque"},{"doc":"","ref":"A.Vector.html#t:value/0","title":"A.Vector.value/0","type":"type"},{"doc":"","ref":"A.Vector.EmptyError.html","title":"A.Vector.EmptyError","type":"exception"},{"doc":"","ref":"A.Vector.IndexError.html","title":"A.Vector.IndexError","type":"exception"},{"doc":"Extension of the Elixir standard library focused on data stuctures and data manipulation.Data structuresUtility functionsInstallationAbout AjaFAQ","ref":"readme.html","title":"README","type":"extras"},{"doc":"&quot;there is one aspect of functional programming that no amount of cleverness on the part of the compiler writer is likely to mitigate — the use of inferior or inappropriate data structures.&quot; -- Chris OkasakiPersistent vectors: A.VectorClojure-like persistent vectors are an efficient alternative to lists, supporting many operations like appends and random access in effective constant time.iex&gt; vector = A.Vector.new(1..10) #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8, 9, 10])&gt; iex&gt; A.Vector.append(vector, :foo) #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, :foo])&gt; iex&gt; vector[3] 4 iex&gt; A.Vector.replace_at(vector, -1, :bar) #A&lt;vec([1, 2, 3, 4, 5, 6, 7, 8, 9, :bar])&gt; iex&gt; 3 in vector trueA.Vector is blazing fast and easier to use from Elixir than Erlang's :array module.A.Vector reimplements many of the functions from the Enum module specifically for vectors, with efficiency in mind.The A.vec/1 and A.vec_size/1 macros, while being totally optional, can make it easier to work with vectors and make pattern-matching possible:iex&gt; import A iex&gt; vec([a, 2, c, _d, e]) = A.Vector.new(1..5) #A&lt;vec([1, 2, 3, 4, 5])&gt; iex&gt; {a, c, e} {1, 3, 5} iex&gt; match?(v when vec_size(v) &gt; 9, vec(1..10)) trueThe A.+++/2 operator can make appending to a vector more explicit:iex&gt; vec([1, 2, 3]) +++ vec([4, 5]) #A&lt;vec([1, 2, 3, 4, 5])&gt;Ordered maps: A.OrdMapThe standard library does not offer any similar functionality:regular maps do not keep track of the insertion orderkeywords do but they only support atoms and do not have the right performance characteristics (plain lists)iex&gt; %{&quot;one&quot; =&gt; 1, &quot;two&quot; =&gt; 2, &quot;three&quot; =&gt; 3} %{&quot;one&quot; =&gt; 1, &quot;three&quot; =&gt; 3, &quot;two&quot; =&gt; 2} iex&gt; ord_map = A.OrdMap.new([{&quot;one&quot;, 1}, {&quot;two&quot;, 2}, {&quot;three&quot;, 3}]) #A&lt;ord(%{&quot;one&quot; =&gt; 1, &quot;two&quot; =&gt; 2, &quot;three&quot; =&gt; 3})&gt; iex&gt; ord_map[&quot;two&quot;] 2 iex&gt; Enum.to_list(ord_map) [{&quot;one&quot;, 1}, {&quot;two&quot;, 2}, {&quot;three&quot;, 3}]Ordered maps behave pretty much like regular maps, and the A.OrdMap module offers the same API as Map. The convenience macro A.ord/1 make them a breeze to instantiate or patter-match upon:iex&gt; import A iex&gt; ord_map = ord(%{&quot;一&quot; =&gt; 1, &quot;二&quot; =&gt; 2, &quot;三&quot; =&gt; 3}) #A&lt;ord(%{&quot;一&quot; =&gt; 1, &quot;二&quot; =&gt; 2, &quot;三&quot; =&gt; 3})&gt; iex&gt; ord(%{&quot;三&quot; =&gt; three, &quot;一&quot; =&gt; one}) = ord_map iex&gt; {one, three} {1, 3}All data structures offer:good performance characteristics at any size (see FAQ)well-documented APIs that are consistent with the standard libraryimplementation of Inspect, Enumerable and Collectable protocolsimplementation of the Access behaviour(optional if Jason is installed) implemention of the Jason.Encoder protocol","ref":"readme.html#data-structures","title":"README - Data structures","type":"extras"},{"doc":"Sigil i for IO dataiex&gt; import A iex&gt; ~i&quot;atom: \#{:foo}, charlist: \#{&#39;abc&#39;}, number: \#{12 + 2.35}\\n&quot; [&quot;atom: &quot;, &quot;foo&quot;, &quot;, charlist: &quot;, &#39;abc&#39;, &quot;, number: &quot;, &quot;14.35&quot;, 10]Exclusive ranges: A.ExRangeiex&gt; A.ExRange.new(0, 10) |&gt; Enum.to_list() [0, 1, 2, 3, 4, 5, 6, 7, 8, 9] iex&gt; import A iex&gt; Enum.map(0 ~&gt; 5, &amp;&quot;id_\#{&amp;1}&quot;) [&quot;id_0&quot;, &quot;id_1&quot;, &quot;id_2&quot;, &quot;id_3&quot;, &quot;id_4&quot;]Don't Break The Pipe!iex&gt; %{foo: &quot;bar&quot;} |&gt; A.Pair.wrap(:noreply) {:noreply, %{foo: &quot;bar&quot;}} iex&gt; {:ok, 55} |&gt; A.Pair.unwrap!(:ok) 55Various other convenience helpersiex&gt; A.String.slugify(&quot;&gt; \\&quot;It Was Me, Dio!!!\\&quot;\\n&quot;) &quot;it-was-me-dio&quot; iex&gt; A.Integer.decimal_format(1234567) &quot;1,234,567&quot; iex&gt; A.Integer.div_rem(7, 3) {2, 1} iex&gt; A.Enum.sort_uniq([1, 4, 2, 2, 3, 1, 4, 3]) [1, 2, 3, 4] iex&gt; A.List.repeatedly(&amp;:rand.uniform/0, 3) [0.40502929729990744, 0.45336720247823126, 0.04094511692041057] iex&gt; A.IO.iodata_empty?([&quot;&quot;, []]) trueNothing groundbreaking, but having these helpers to hand might save you the implementation and the testing, or bringing over a library just for this one thing.Browse the API documentation for more details.","ref":"readme.html#utility-functions","title":"README - Utility functions","type":"extras"},{"doc":"Aja can be installed by adding aja to your list of dependencies in mix.exs:def deps do [ {:aja, &quot;~&gt; 0.4.8&quot;} ] endDocumentation can be found at https://hexdocs.pm/aja.","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Inspirationsthe amazingly polished Elixir standard library: self-consistent, well-documented and just delightful ✨️the also amazing Python standard library, notably its collections modulethe amazing lodash which complements nicely the (historically rather small) javascript standard library, with a very consistent APIvarious work on efficient persistent data structures spearheaded by Okasaki (see resources section below)Clojure's persistent vectors, by Rich Hickey and influenced by Phil BagwellGoalslike the standard library, being delightful to use ✨️ (consistency with Elixir and itself, quality, documentation)no external dependency to help you preserve a decent dependency treeperformance-conscious (right algorithm, proper benchmarking, fast compile times*)mostly dead-simple pure functions: no configuration, no mandatory macro, no statefulness / OTP(* while fast compile time is a target, A.Vector, which is optimized for fast runtime at the expense of compile time, slows it down)Non-goalsadd every possible feature that has not been accepted in elixir core (Aja is opinionated!)touching anything OTP-related / statefulResourcesChris Okasaki's Purely Functional Data StructuresJean Niklas L'orange's articles and thesis about persistent vectors and RRB trees","ref":"readme.html#about-aja","title":"README - About Aja","type":"extras"},{"doc":"How stable is it?Aja is still pretty early stage and the high-level organisation is still in flux. Expect some breaking changes until it reaches maturity.However, many of its APIs are based on the standard library and should therefore remain fairly stable.Besides, Aja is tested quite thoroughly both with unit tests and property-based testing (especially for data structures). This effort is far from perfect, but increases our confidence in the overall reliability.How is the performance?VectorsMost operations from A.Vector are much faster than Erlang's :array equivalents, and in some cases are even slightly faster than equivalent list operations (map, folds, join, sum...).There is one exception where A.Vector can be slightly slower than :array: random access for small collections. For bigger collections however, the higher branching factor for vectors (16 vs 10) should close this gap.MapsPerformance for ordered maps cannot match native maps and has an important overhead.BenchmarksAja data structures should work fine in most cases, but if you're considering them for performance-critical sections of your code, make sure to benchmark them.Benchmarking is still a work in progress, but you can check the bench folder for more detailed figures.Does Aja try to do too much?The Unix philosophy of &quot;Do one thing and do it well&quot; is arguably the right approach in many cases. Aja doesn't really follow it, but there are conscious reasons for going that direction.While it might be possible later down the road to split some of its components, there is no plan to do so at the moment.First, we don't think there is any real downside of shipping &quot;too much&quot;: Aja is and aims to remain lightweight and keep a modular structure. You can just use what you need without suffering from what you don't.This lodash-like approach has benefits too: it aims to ship with a lot of convenience while introducing only one flat dependency. This can help staying out of two extreme paths:the &quot;leftpad way&quot;, where every project relies on a ton of small dependencies, ending up with un-manageable dependency trees and brittle software.the &quot;Lisp Curse way&quot;, where everybody keeps rewriting the same thing over and over because nobody wants the extra dependency. Being a hidden Lisp with similar super powers and expressiveness, Elixir might make it relatively easy and tempting to go down that path.Finally, data structures can work more efficiently together than if they were separated libraries.What are the next steps?Nothing is set in stone, but the next steps will probably be:complete the API for A.Vector and improve its ergonomicsmore benchmarks and performance optimizations","ref":"readme.html#faq","title":"README - FAQ","type":"extras"},{"doc":"Aja is licensed under the MIT License.","ref":"readme.html#copyright-and-license","title":"README - Copyright and License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#dev","title":"Changelog - Dev","type":"extras"},{"doc":"EnhancementsAdd A.Vector.map_reduce/3Add A.Vector.scan/2 and A.Vector.scan/3A.Vector.with_index/2 accepts a function parameterBreaking changesDeprecate A.RBMap and A.RBSetBug fixesFix A.Vector.join/2 bug when working with chardata","ref":"changelog.html#v0-4-8-2021-02-23","title":"Changelog - v0.4.8 (2021-02-23)","type":"extras"},{"doc":"EnhancementsAdd A.Vector.reduce/2 and A.Vector.reduce/3Add A.Vector.split/2 and A.Vector.split_with/2Add A.Vector.frequencies/1 and A.Vector.frequencies_by/2Add A.Vector.group_by/3Add A.Vector.dedup/1 and A.Vector.dedup_by/2Add A.Vector.min/2, A.Vector.max/2, A.Vector.min_by/3, A.Vector.max_by/3Improve performance for A.Vector.min/1, A.Vector.max/1 and A.Vector.uniq/1","ref":"changelog.html#v0-4-7-2021-02-19","title":"Changelog - v0.4.7 (2021-02-19)","type":"extras"},{"doc":"EnhancementsAdd A.Vector.find_index/2Add A.Vector.take_while/2, A.Vector.drop_while/2 and A.Vector.split_while/2Add A.Vector.zip/2 and A.Vector.unzip/1Add A.Vector.fetch!/2 alias","ref":"changelog.html#v0-4-6-2021-02-10","title":"Changelog - v0.4.6 (2021-02-10)","type":"extras"},{"doc":"EnhancementsAdd A.Vector.find/3 and A.Vector.find_value/3Add A.+++/2 convenience operatorImprove efficiency of vector access functions: A.Vector.at/2, A.Vector.fetch/2, A.Vector.replace_at/3, A.Vector.delete_at/2... ⚡️Improve compile timesBug fixesInvoke callbacks in the right order for: A.Vector.filter/2, A.Vector.reject/2 and improve performance","ref":"changelog.html#v0-4-5-2021-01-31","title":"Changelog - v0.4.5 (2021-01-31)","type":"extras"},{"doc":"EnhancementsAdd A.vec_size/1 macroAdd A.Vector.with_index/2Add A.Vector.random/1, A.Vector.take_random/2 and A.Vector.shuffle/1Drastically improve efficiency of A.Vector.duplicate/2 ⚡️⚡️⚡️Breaking changesChanged internal representation of A.Vector (only breaking if persisted)Stop documenting and exposing internal trees (A.RBTree)Rename and deprecate A.Vector.append_many/2 to A.Vector.concat/2","ref":"changelog.html#v0-4-4-2021-01-23","title":"Changelog - v0.4.4 (2021-01-23)","type":"extras"},{"doc":"This release is mostly focused on vector slicing and performance ⚡️EnhancementsAdd A.Vector.each/2Add A.Vector.slice/2, A.Vector.slice/3, A.Vector.take/2 and A.Vector.drop/2A.Vector efficiently implements Enumerable.slice/1Reimplement A.Vector.delete_at/2, A.Vector.pop_at/2 efficiently","ref":"changelog.html#v0-4-3-2021-01-12","title":"Changelog - v0.4.3 (2021-01-12)","type":"extras"},{"doc":"EnhancementsImplement A.Vector.product/1Bug fixesInvoke callbacks in the right order for: A.Vector.map/2, A.Vector.map_intersperse/3, A.Vector.map_join/3, A.Vector.any?/2, A.Vector.all?/2","ref":"changelog.html#v0-4-2-2021-01-10","title":"Changelog - v0.4.2 (2021-01-10)","type":"extras"},{"doc":"EnhancementsAdd A.Vector.map_join/3 and A.Vector.map_intersperse/3Implement A.Vector.intersperse/2 more efficientlyBug fixesA.Vector.sum/1 adds using the same order as Enum.sum/1, avoiding slight inconsistencies for floats","ref":"changelog.html#v0-4-1-2020-12-05","title":"Changelog - v0.4.1 (2020-12-05)","type":"extras"},{"doc":"EnhancementsIntroduce persistent vectors: A.Vector 🚀️Add A.vec/1","ref":"changelog.html#v0-4-0-2020-12-02","title":"Changelog - v0.4.0 (2020-12-02)","type":"extras"},{"doc":"EnhancementsAdd A.sigil_i/2Add A.IO.to_iodata/1","ref":"changelog.html#v0-3-3-2020-11-14","title":"Changelog - v0.3.3 (2020-11-14)","type":"extras"},{"doc":"EnhancementsAdd A.Enum.sort_uniq/1, A.Enum.sort_uniq/2Add A.List.prepend/2","ref":"changelog.html#v0-3-2-2020-11-14","title":"Changelog - v0.3.2 (2020-11-14)","type":"extras"},{"doc":"Bug fixesA.RBMap.Enumerable.member?/2 returns false instead of crashing for values other than size-2 tuples","ref":"changelog.html#v0-3-1-2020-11-05","title":"Changelog - v0.3.1 (2020-11-05)","type":"extras"},{"doc":"EnhancementsRework all internals, improved peformance for A.OrdMap, A.RBMap, A.RBSetAdd default parameter to A.OrdMap.first/1, A.OrdMap.last/1, A.RBMap.first/1, A.RBMap.last/1, A.RBSet.first/1, A.RBSet.last/1Breaking changesChanged signature of A.OrdMap.foldl/3, A.OrdMap.foldr/3, A.RBMap.foldl/3, A.RBMap.foldr/3Internals of all data structures have been changedSplit A.RBTree as A.RBTree.Map and A.RBTree.Set","ref":"changelog.html#v0-3-0-2020-10-31","title":"Changelog - v0.3.0 (2020-10-31)","type":"extras"},{"doc":"EnhancementsAdd A.String.slugify/2Breaking changesRemove A.Array module","ref":"changelog.html#v0-2-0-2020-10-25","title":"Changelog - v0.2.0 (2020-10-25)","type":"extras"},{"doc":"EnhancementsAdd pop_first/1 and pop_last/1 to A.RBMap, A.RBSet and A.OrdMapAdd some guards to functionsBug fixesA.RBSet.disjoint?/2 was not returning the expected value","ref":"changelog.html#v0-1-2-2020-10-22","title":"Changelog - v0.1.2 (2020-10-22)","type":"extras"},{"doc":"Bug fixesFix incompatibility with Elixir 1.10","ref":"changelog.html#v0-1-1-2020-10-21","title":"Changelog - v0.1.1 (2020-10-21)","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0-2020-10-18","title":"Changelog - v0.1.0 (2020-10-18)","type":"extras"},{"doc":"MIT LicenseCopyright (c) 2020 SabiwaraPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]